'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};











var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();









var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};











var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};



















var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var _class = function () {
  function _class(url, transmitHeaders, defaultResponder) {
    var _this = this;

    classCallCheck(this, _class);

    this.baseUrl = url || '';
    this.upHeaders = {};
    this.transmitHeaders = transmitHeaders || [];
    this.responders = {};
    if (defaultResponder && defaultResponder instanceof Function) {
      this.responders.default = defaultResponder;
    } else {
      this.responders.default = function (r) {
        console.error('no responder for ' + r.argot, r, _this.responders);
      };
    }
  }

  createClass(_class, [{
    key: 'setUpHeaders',
    value: function setUpHeaders(k, v) {
      this.upHeaders[k] = v;
    }
  }, {
    key: 'registerResponder',
    value: function registerResponder(k, v) {
      this.responders[k] = v;
    }
  }, {
    key: 'unregisterResponder',
    value: function unregisterResponder(k) {
      delete this.responders[k];
    }
  }, {
    key: 'get',
    value: function get$$1(_ref) {
      var path = _ref.path,
          headers = _ref.headers,
          context = _ref.context,
          timeout = _ref.timeout;

      return this.request('GET', { path: path, headers: headers, context: context, timeout: timeout });
    }
  }, {
    key: 'post',
    value: function post(_ref2) {
      var path = _ref2.path,
          data = _ref2.data,
          headers = _ref2.headers,
          context = _ref2.context,
          timeout = _ref2.timeout;

      return this.request('POST', { path: path, data: data, headers: headers, context: context, timeout: timeout });
    }
  }, {
    key: 'put',
    value: function put(_ref3) {
      var path = _ref3.path,
          data = _ref3.data,
          headers = _ref3.headers,
          context = _ref3.context,
          timeout = _ref3.timeout;

      return this.request('PUT', { path: path, data: data, headers: headers, context: context, timeout: timeout });
    }
  }, {
    key: 'delete',
    value: function _delete(_ref4) {
      var path = _ref4.path,
          data = _ref4.data,
          headers = _ref4.headers,
          context = _ref4.context,
          timeout = _ref4.timeout;

      return this.request('DELETE', { path: path, data: data, headers: headers, context: context, timeout: timeout });
    }

    //
    // mustPost ({ path, data, headers, context, timeout }) {
    //   return this.request('POST', { path, data, headers, context, timeout, must: true })
    // }
    //
    // mustPut ({ path, data, headers, context, timeout }) {
    //   return this.request('PUT', { path, data, headers, context, timeout, must: true })
    // }
    //
    // mustDelete ({ path, data, headers, context, timeout }) {
    //   return this.request('DELETE', { path, data, headers, context, timeout, must: true })
    // }

  }, {
    key: 'head',
    value: function head(_ref5) {
      var path = _ref5.path,
          data = _ref5.data,
          headers = _ref5.headers,
          context = _ref5.context,
          timeout = _ref5.timeout;

      return this.request('HEAD', { path: path, data: data, headers: headers, context: context, timeout: timeout });
    }
  }, {
    key: 'request',
    value: function request(method, _ref6) {
      var _this2 = this;

      var path = _ref6.path,
          data = _ref6.data,
          headers = _ref6.headers,
          context = _ref6.context,
          timeout = _ref6.timeout;

      if (!timeout) timeout = 30000;
      var ac = new AbortController();
      var option = {
        signal: ac.signal,
        method: method || 'GET',
        headers: headers || {}
      };

      for (var k in this.upHeaders) {
        option.headers[k] = this.upHeaders[k];
      }

      if (data) {
        if (data instanceof HTMLFormElement) {
          option.body = new FormData(data);
        } else if (data instanceof FormData) {
          option.body = data;
        } else if (typeof data === 'string') {
          option.body = data;
          option.headers['Content-Type'] = 'application/x-www-form-urlencoded';
          option.headers['Content-Length'] = option.body.length;
        } else {
          option.body = JSON.stringify(data);
          option.headers['Content-Type'] = 'application/json';
          option.headers['Content-Length'] = option.body.length;
        }
      }

      // TODO must
      var request = { method: method, path: path, data: data, headers: headers, context: context, timeout: timeout };
      var response = {
        headers: {},
        status: 0
      };

      var timeoutPromise = new Promise(function (resolve, reject) {
        setTimeout(function () {
          reject({ ok: false, message: 'Timeout', argot: 'HintBadNetwork', _request: request, _response: response, _context: context });
          ac.abort();
        }, timeout);
      });

      var requestPromise = fetch(path, option).then(function (r) {
        response.status = r.status;
        response.headers = r.headers;
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = _this2.transmitHeaders[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var key = _step.value;

            var value = r.headers.get(key);
            if (value) {
              _this2.upHeaders[key] = value;
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        return r.text();
      });

      // 成功才会调用 resolve, 其他情况一律交给 responder 处理
      return new Promise(function (resolve, reject) {
        Promise.race([timeoutPromise, requestPromise]).then(function (text) {
          var r = void 0;
          try {
            r = JSON.parse(text);
          } catch (e) {
            r = { ok: false, message: text, argot: 'BadResponse' };
          }

          if (!r) r = { ok: false, message: '', argot: 'BadResponse' };
          r._request = request;
          r._response = response;
          r._context = context;

          if (r.ok) {
            resolve(r);
          } else {
            if (r.argot) {
              setTimeout(function () {
                if (!_this2._getResponder(r.argot)(r)) reject(r);
              });
            } else {
              reject(r);
            }
          }
        }).catch(function (e) {
          var r = { ok: false, message: e.toString(), argot: 'HintBadNetwork', _request: request, _response: response, _context: context };
          if (r.argot) {
            setTimeout(function () {
              if (!_this2._getResponder(r.argot)(r)) reject(r);
            });
          } else {
            reject(r);
          }
        });
      });
    }
  }, {
    key: '_getResponder',
    value: function _getResponder(argot) {
      var responder = this.responders[argot];
      if (!responder) responder = this.responders.default;
      return responder;
    }
  }]);
  return _class;
}();

var _class$2 = function () {
  function _class(url, _ref) {
    var onopen = _ref.onopen,
        onmessage = _ref.onmessage,
        onerror = _ref.onerror,
        onclose = _ref.onclose,
        pingTimeout = _ref.pingTimeout;
    classCallCheck(this, _class);

    this.url = url;
    this.onopen = onopen || null;
    this.onmessage = onmessage || null;
    this.onerror = onerror || null;
    this.onclose = onclose || null;
    this.pingTimeout = pingTimeout || 5000;
    this.conn = null;
    this.running = false;
    this.reconnecting = false;
    this.checkerId = 0;
    this.checkerIndex = 0;
    this.lastPingTime = 0;
  }

  createClass(_class, [{
    key: 'start',
    value: function start() {
      if (!this.running) {
        this.running = true;
        this.connect();
        this.checkerId = setInterval(this.check.bind(this), 1000);
      }
    }
  }, {
    key: 'stop',
    value: function stop() {
      if (this.running) {
        this.running = false;
        if (this.conn) this.conn.close();
        clearInterval(this.checkerId);
        this.conn = null;
      }
    }
  }, {
    key: 'check',
    value: function check() {
      if (!this.running) return;

      this.checkerIndex++;
      if (this.conn) {
        if (this.lastPingTime && new Date().getTime() - this.lastPingTime >= this.pingTimeout) {
          if (this.conn && this.conn.readyState !== WebSocket.CLOSED && this.conn.readyState !== WebSocket.CLOSING) this.conn.close();
          this.connect();
          this.lastPingTime = 0;
        }

        if (this.checkerIndex >= 3) {
          if (this.conn.readyState === WebSocket.OPEN) {
            if (this.lastPingTime === 0) {
              this.lastPingTime = new Date().getTime();
              this.conn.send('PING');
            }
          } else if (this.conn.readyState === WebSocket.CLOSED && !this.reconnecting) {
            this.connect();
          }
        }
      }
      if (this.checkerIndex >= 3) this.checkerIndex = 0;
    }
  }, {
    key: 'connect',
    value: function connect() {
      var _this = this;

      if (!this.running) return;
      if (this.conn && (this.conn.readyState === WebSocket.OPEN || this.conn.readyState === WebSocket.CONNECTING)) return;

      this.reconnecting = false;
      var conn = new WebSocket(this.url);
      this.conn = conn;
      this.conn.onopen = this.onopen;
      this.conn.onmessage = function (e) {
        _this.lastPingTime = 0;
        if (e.data !== 'PONG' && _this.onmessage) {
          _this.onmessage(e);
        }
      };
      this.conn.onerror = this.onerror;
      this.conn.onclose = function () {
        if (_this.running && _this.conn === conn) {
          if (_this.onclose) _this.onclose();
          setTimeout(_this.connect.bind(_this), 1000);
          _this.reconnecting = true;
        }
      };
    }
  }]);
  return _class;
}();

var $ = function $(id, from, inRoute) {
  if (!from) from = document.body;
  if (typeof from === 'string') from = $(from);
  if (!id) return from;
  if (typeof id !== 'string') return id;

  if (inRoute && from) {
    var nodes = $.all(id, from, inRoute);
    if (nodes.length > 0) return nodes[0];
    return null;
  }

  return from.querySelector(id);
};

$.all = function (id, callback, from, inRoute) {
  if (!from) from = document.body;
  if (typeof from === 'string') from = $(from);
  if (callback instanceof HTMLElement) {
    from = callback;
    callback = null;
  }

  // let nodes = from.querySelectorAll(id)
  var nodes = [];
  if (typeof id === 'string') {
    nodes = from.querySelectorAll(id);
  } else {
    nodes = [id];
  }
  // for (let node of nodes) {
  //   if (id === '[events]' && node.getAttribute('events') === 'dragover,drop') {
  //     console.info(' ###', node.getAttribute('events'), node)
  //   }
  // }

  // 在路由中排除SUBVIEW
  if (inRoute && from) {
    var fixedNodes = [];
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = nodes[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var node = _step.value;

        var ok = true;
        var findNode = node;
        while (findNode && findNode !== from) {
          if (findNode.id && findNode.id.startsWith('SUBVIEW_')) {
            ok = false;
            break;
          }
          findNode = findNode.parentNode;
        }
        if (ok) fixedNodes.push(node);
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    nodes = fixedNodes;
  }

  if (callback && callback instanceof Function) {
    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
      for (var _iterator2 = nodes[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
        var _node = _step2.value;

        callback(_node);
      }
    } catch (err) {
      _didIteratorError2 = true;
      _iteratorError2 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion2 && _iterator2.return) {
          _iterator2.return();
        }
      } finally {
        if (_didIteratorError2) {
          throw _iteratorError2;
        }
      }
    }
  } else {
    return nodes;
  }
};

$.clear = function (node) {
  if (typeof node === 'string') node = $(node);
  while (node.childNodes.length) {
    node.removeChild(node.childNodes[0]);
  }
};

$.show = function (id, from) {
  if (!id) return;
  $.all(id, function (node) {
    if (!node) return;
    var display = node.getAttribute('display') || 'block';
    if (display === 'visibility') {
      node.style.visibility = 'visible';
    } else {
      node.style.display = display;
    }
    var renderBox = node.hasAttribute('renderBox') ? node : $('[renderBox]', node);
    if (renderBox && renderBox.renderAction) renderBox.renderAction(); // 动态渲染对象触发一次滚动
  }, from);
};

$.hide = function (id, from) {
  if (!id) return;
  $.all(id, function (node) {
    if (!node) return;
    var display = node.getAttribute('display') || 'block';
    if (display === 'visibility') {
      node.style.visibility = 'hidden';
    } else {
      node.style.display = 'none';
    }
  }, from);
};

$.childs = function (id, from) {
  if (id instanceof HTMLElement) {
    return [id];
  } else {
    return $.all(id, null, from);
  }
};

$.hasClass = function (id, className, from) {
  var _iteratorNormalCompletion3 = true;
  var _didIteratorError3 = false;
  var _iteratorError3 = undefined;

  try {
    for (var _iterator3 = $.childs(id, from)[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
      var node = _step3.value;

      if (node.className && node.className.split) {
        var a = node.className.split(/\s+/);
        if (a.indexOf(className) !== -1) {
          return true;
        }
      }
    }
  } catch (err) {
    _didIteratorError3 = true;
    _iteratorError3 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion3 && _iterator3.return) {
        _iterator3.return();
      }
    } finally {
      if (_didIteratorError3) {
        throw _iteratorError3;
      }
    }
  }

  return false;
};

$.addClass = function (id, classNames, from) {
  var _iteratorNormalCompletion4 = true;
  var _didIteratorError4 = false;
  var _iteratorError4 = undefined;

  try {
    for (var _iterator4 = $.childs(id, from)[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
      var node = _step4.value;

      if (node.className !== undefined && node.className.split) {
        var a = node.className.split(/\s+/);
        var _iteratorNormalCompletion5 = true;
        var _didIteratorError5 = false;
        var _iteratorError5 = undefined;

        try {
          for (var _iterator5 = classNames.split(' ')[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
            var className = _step5.value;

            if (a.indexOf(className) === -1) {
              a.push(className);
            }
          }
        } catch (err) {
          _didIteratorError5 = true;
          _iteratorError5 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion5 && _iterator5.return) {
              _iterator5.return();
            }
          } finally {
            if (_didIteratorError5) {
              throw _iteratorError5;
            }
          }
        }

        node.className = a.join(' ');
      }
    }
  } catch (err) {
    _didIteratorError4 = true;
    _iteratorError4 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion4 && _iterator4.return) {
        _iterator4.return();
      }
    } finally {
      if (_didIteratorError4) {
        throw _iteratorError4;
      }
    }
  }
};

$.addClassAutoRemove = function (id, className, from, delay) {
  return new Promise(function (resolve) {
    $.addClass(id, className, from);
    setTimeout(function () {
      $.removeClass(id, className, from);
      resolve();
    }, delay || 1000);
  });
};

$.removeClass = function (id, classNames, from) {
  var _iteratorNormalCompletion6 = true;
  var _didIteratorError6 = false;
  var _iteratorError6 = undefined;

  try {
    for (var _iterator6 = $.childs(id, from)[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
      var node = _step6.value;

      if (node.className !== undefined && node.className.split) {
        var a = node.className.split(/\s+/);
        var _iteratorNormalCompletion7 = true;
        var _didIteratorError7 = false;
        var _iteratorError7 = undefined;

        try {
          for (var _iterator7 = classNames.split(' ')[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
            var className = _step7.value;

            var pos = a.indexOf(className);
            if (pos !== -1) {
              a.splice(pos, 1);
            }
          }
        } catch (err) {
          _didIteratorError7 = true;
          _iteratorError7 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion7 && _iterator7.return) {
              _iterator7.return();
            }
          } finally {
            if (_didIteratorError7) {
              throw _iteratorError7;
            }
          }
        }

        node.className = a.join(' ');
      }
    }
  } catch (err) {
    _didIteratorError6 = true;
    _iteratorError6 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion6 && _iterator6.return) {
        _iterator6.return();
      }
    } finally {
      if (_didIteratorError6) {
        throw _iteratorError6;
      }
    }
  }
};

$.toggleClass = function (id, className, from) {
  var _iteratorNormalCompletion8 = true;
  var _didIteratorError8 = false;
  var _iteratorError8 = undefined;

  try {
    for (var _iterator8 = $.childs(id, from)[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
      var node = _step8.value;

      if (node.className !== undefined && node.className.split) {
        var a = node.className.split(/\s+/);
        var pos = a.indexOf(className);
        if (pos !== -1) {
          a.splice(pos, 1);
          node.className = a.join(' ');
        } else {
          a.push(className);
          node.className = a.join(' ');
        }
      }
    }
  } catch (err) {
    _didIteratorError8 = true;
    _iteratorError8 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion8 && _iterator8.return) {
        _iterator8.return();
      }
    } finally {
      if (_didIteratorError8) {
        throw _iteratorError8;
      }
    }
  }
};

$.keysBy = function (obj) {
  for (var _len = arguments.length, fieldAndValues = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    fieldAndValues[_key - 1] = arguments[_key];
  }

  var keys = [];
  for (var k in obj) {
    var match = true;
    if (fieldAndValues.length === 1) {
      // 查找一位数组
      if (obj[k] != fieldAndValues[0]) {
        match = false;
      }
    } else {
      // 查找二维数组
      for (var i = 0; i < fieldAndValues.length; i += 2) {
        if (obj[k][fieldAndValues[i]] != fieldAndValues[i + 1]) {
          match = false;
          break;
        }
      }
    }
    if (match) {
      keys.push(k);
    }
  }
  return keys;
};

$.listBy = function (obj) {
  for (var _len2 = arguments.length, fieldAndValues = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    fieldAndValues[_key2 - 1] = arguments[_key2];
  }

  var list = obj instanceof Array ? [] : {};
  var keys = $.keysBy.apply($, [obj].concat(fieldAndValues));
  var _iteratorNormalCompletion9 = true;
  var _didIteratorError9 = false;
  var _iteratorError9 = undefined;

  try {
    for (var _iterator9 = keys[Symbol.iterator](), _step9; !(_iteratorNormalCompletion9 = (_step9 = _iterator9.next()).done); _iteratorNormalCompletion9 = true) {
      var k = _step9.value;

      if (obj instanceof Array) {
        list.push(obj[k]);
      } else {
        list[k] = obj[k];
      }
    }
  } catch (err) {
    _didIteratorError9 = true;
    _iteratorError9 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion9 && _iterator9.return) {
        _iterator9.return();
      }
    } finally {
      if (_didIteratorError9) {
        throw _iteratorError9;
      }
    }
  }

  return list;
};

$.hasBy = function (obj) {
  for (var _len3 = arguments.length, fieldAndValues = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
    fieldAndValues[_key3 - 1] = arguments[_key3];
  }

  var keys = $.keysBy.apply($, [obj].concat(fieldAndValues));
  return keys.length > 0;
};

$.getBy = function (obj) {
  for (var _len4 = arguments.length, fieldAndValues = Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
    fieldAndValues[_key4 - 1] = arguments[_key4];
  }

  var keys = $.keysBy.apply($, [obj].concat(fieldAndValues));
  if (keys.length > 0) return obj[keys[0]];
  return null;
};

$.setBy = function (obj, value) {
  for (var _len5 = arguments.length, fieldAndValues = Array(_len5 > 2 ? _len5 - 2 : 0), _key5 = 2; _key5 < _len5; _key5++) {
    fieldAndValues[_key5 - 2] = arguments[_key5];
  }

  var keys = $.keysBy.apply($, [obj].concat(fieldAndValues));
  if (keys.length > 0) obj[keys[0]] = value;
};

$.indexBy = function (obj) {
  for (var _len6 = arguments.length, fieldAndValues = Array(_len6 > 1 ? _len6 - 1 : 0), _key6 = 1; _key6 < _len6; _key6++) {
    fieldAndValues[_key6 - 1] = arguments[_key6];
  }

  var keys = $.keysBy.apply($, [obj].concat(fieldAndValues));
  if (keys.length > 0) {
    return obj instanceof Array ? $.int(keys[0]) : keys[0];
  }
  return -1;
};

$.removeBy = function (obj) {
  for (var _len7 = arguments.length, fieldAndValues = Array(_len7 > 1 ? _len7 - 1 : 0), _key7 = 1; _key7 < _len7; _key7++) {
    fieldAndValues[_key7 - 1] = arguments[_key7];
  }

  var keys = $.keysBy.apply($, [obj].concat(fieldAndValues));
  var n = 0;
  for (var i = keys.length - 1; i >= 0; i--) {
    var k = keys[i];
    if (obj instanceof Array) {
      obj.splice(k, 1);
    } else {
      delete obj[k];
    }
    n++;
  }
  return n;
};

$.removeArrayItem = function (list, item) {
  var pos = list.indexOf(item);
  if (pos !== -1) list.splice(pos, 1);
};

$.last = function (arr) {
  if (arr && arr.length) {
    return arr[arr.length - 1];
  }
  return null;
};

$.len = function (obj) {
  if (obj instanceof Array) {
    return obj.length;
  } else {
    var n = 0;
    for (var k in obj) {
      n++;
    }return n;
  }
};

$.mergeBy = function (olds, news) {
  for (var _len8 = arguments.length, fields = Array(_len8 > 2 ? _len8 - 2 : 0), _key8 = 2; _key8 < _len8; _key8++) {
    fields[_key8 - 2] = arguments[_key8];
  }

  if (!olds) return news;
  var _iteratorNormalCompletion10 = true;
  var _didIteratorError10 = false;
  var _iteratorError10 = undefined;

  try {
    for (var _iterator10 = news[Symbol.iterator](), _step10; !(_iteratorNormalCompletion10 = (_step10 = _iterator10.next()).done); _iteratorNormalCompletion10 = true) {
      var newItem = _step10.value;

      var fieldAndValues = [];
      var _iteratorNormalCompletion11 = true;
      var _didIteratorError11 = false;
      var _iteratorError11 = undefined;

      try {
        for (var _iterator11 = fields[Symbol.iterator](), _step11; !(_iteratorNormalCompletion11 = (_step11 = _iterator11.next()).done); _iteratorNormalCompletion11 = true) {
          var field = _step11.value;

          fieldAndValues.push(field, newItem[field]);
        }
      } catch (err) {
        _didIteratorError11 = true;
        _iteratorError11 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion11 && _iterator11.return) {
            _iterator11.return();
          }
        } finally {
          if (_didIteratorError11) {
            throw _iteratorError11;
          }
        }
      }

      var oldIndex = $.indexBy.apply($, [olds].concat(fieldAndValues));
      if (oldIndex === -1) {
        olds.push(newItem);
      } else {
        olds[oldIndex] = newItem;
      }
    }
  } catch (err) {
    _didIteratorError10 = true;
    _iteratorError10 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion10 && _iterator10.return) {
        _iterator10.return();
      }
    } finally {
      if (_didIteratorError10) {
        throw _iteratorError10;
      }
    }
  }

  return olds;
};

$.sortBy = function (obj, field) {
  var isReverse = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

  var list = obj instanceof Array ? [] : {};
  var sortedKeys = {};
  var sortArr = [];
  for (var k in obj) {
    if (!sortedKeys[obj[k][field]]) {
      sortedKeys[obj[k][field]] = true;
      sortArr.push(obj[k][field]);
    }
  }
  sortArr.sort(function (a, b) {
    if (a == b) return 0;
    if (typeof a === 'number' && typeof b === 'number') {
      return isReverse ? b - a : a - b;
    } else {
      return (isReverse ? a < b : a > b) ? 1 : -1;
    }
  });
  var _iteratorNormalCompletion12 = true;
  var _didIteratorError12 = false;
  var _iteratorError12 = undefined;

  try {
    for (var _iterator12 = sortArr[Symbol.iterator](), _step12; !(_iteratorNormalCompletion12 = (_step12 = _iterator12.next()).done); _iteratorNormalCompletion12 = true) {
      var sortKey = _step12.value;

      for (var _k in obj) {
        if (obj instanceof Array) {
          if (obj[_k][field] == sortKey) list.push(obj[_k]);
        } else {
          if (obj[_k][field] == sortKey) list[_k] = obj[_k];
        }
      }
    }
  } catch (err) {
    _didIteratorError12 = true;
    _iteratorError12 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion12 && _iterator12.return) {
        _iterator12.return();
      }
    } finally {
      if (_didIteratorError12) {
        throw _iteratorError12;
      }
    }
  }

  return list;
};

$.inSet = function (v1, v2) {
  if (!(v1 instanceof Array)) v1 = String(v1).split(/,\s*/);
  return v1.indexOf(String(v2)) !== -1;
};

$.copy = function (obj) {
  var newObj = void 0;
  if (obj instanceof Array) {
    newObj = [];
    var _iteratorNormalCompletion13 = true;
    var _didIteratorError13 = false;
    var _iteratorError13 = undefined;

    try {
      for (var _iterator13 = obj[Symbol.iterator](), _step13; !(_iteratorNormalCompletion13 = (_step13 = _iterator13.next()).done); _iteratorNormalCompletion13 = true) {
        var o = _step13.value;

        if ((typeof o === 'undefined' ? 'undefined' : _typeof(o)) === 'object' && o) o = $.copy(o);
        newObj.push(o);
      }
    } catch (err) {
      _didIteratorError13 = true;
      _iteratorError13 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion13 && _iterator13.return) {
          _iterator13.return();
        }
      } finally {
        if (_didIteratorError13) {
          throw _iteratorError13;
        }
      }
    }
  } else {
    newObj = {};
    for (var k in obj) {
      var v = obj[k];
      if ((typeof v === 'undefined' ? 'undefined' : _typeof(v)) === 'object' && v) v = $.copy(v);
      newObj[k] = v;
    }
  }

  return newObj;
};

$.domIndex = function (dom) {
  if (dom && dom.parentNode) {
    var nodes = dom.parentNode.children;
    var index = -1;
    for (var i = 0; i < nodes.length; i++) {
      if (nodes[i] === dom) {
        index = i;
        break;
      }
    }
    return index;
  }
  return -1;
};

var _loaded = false;
var _tasks = [];

addEventListener('load', function () {
  _loaded = true;
  var _iteratorNormalCompletion14 = true;
  var _didIteratorError14 = false;
  var _iteratorError14 = undefined;

  try {
    for (var _iterator14 = _tasks[Symbol.iterator](), _step14; !(_iteratorNormalCompletion14 = (_step14 = _iterator14.next()).done); _iteratorNormalCompletion14 = true) {
      var task = _step14.value;

      task();
    }
  } catch (err) {
    _didIteratorError14 = true;
    _iteratorError14 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion14 && _iterator14.return) {
        _iterator14.return();
      }
    } finally {
      if (_didIteratorError14) {
        throw _iteratorError14;
      }
    }
  }
});

$.runWhenLoaded = function (task, override) {
  if (_loaded) {
    task();
  } else {
    if (override && _tasks.length) _tasks = []; // 覆盖之前的任务
    _tasks.push(task);
  }
};

$.formatDate = function (date, fmt, timezone) {
  var ret = void 0;
  if (!date) return '';

  // console.info(11, date, fmt)
  var opt = {
    'YYYY': date.getFullYear().toString(), // 年
    'YY': date.getFullYear().toString().substring(2), // 年
    'm+': (date.getMonth() + 1).toString(), // 月
    'd+': date.getDate().toString(), // 日
    'H+': date.getHours().toString(), // 时
    'h+': (date.getHours() % 12).toString(), // 12时制
    'APM': date.getHours() > 12 ? 'PM' : 'AM', // 12时制
    'M+': date.getMinutes().toString(), // 分
    'S+': date.getSeconds().toString(), // 秒
    'YW': 'W' + Math.ceil((date.getTime() - new Date(date.getFullYear(), 0, 0)) / (24 * 60 * 60 * 1000) / 7) // 第几周
  };
  for (var k in opt) {
    ret = new RegExp('(' + k + ')').exec(fmt);
    if (ret) {
      fmt = fmt.replace(ret[1], ret[1].length == 1 ? opt[k] : opt[k].padStart(ret[1].length, '0'));
    }
  }
  // console.info(111, fmt)
  return fmt;
};

$.parseDate = function (str) {
  // 2006-01-02 15:03:04
  if (typeof str === 'number') str = str + '';
  if (/^\d+[\\.]?\d*$/.test(str)) {
    if (str.length === 10) str += '000';
    return new Date($.int(str));
  }
  if (str.length === 19) {
    return new Date(parseInt(str.substr(0, 4)), parseInt(str.substr(5, 2)) - 1, parseInt(str.substr(8, 2)), parseInt(str.substr(11, 2)), parseInt(str.substr(14, 2)), parseInt(str.substr(17, 2)));
  } else if (str.length === 10) {
    return new Date(parseInt(str.substr(0, 4)), parseInt(str.substr(5, 2)) - 1, parseInt(str.substr(8, 2)));
  } else if (str.length === 7) {
    return new Date(parseInt(str.substr(0, 4)), parseInt(str.substr(5, 2)) - 1, 1);
  } else if (str.length === 8) {
    var date = new Date();
    return new Date(date.getFullYear(), date.getMonth(), date.getDate(), parseInt(str.substr(0, 2)), parseInt(str.substr(3, 2)), parseInt(str.substr(6, 2)));
  } else if (str.length === 5) {
    var _date = new Date();
    return new Date(_date.getFullYear(), _date.getMonth(), _date.getDate(), parseInt(str.substr(0, 2)), parseInt(str.substr(3, 2)), 0);
  }
  return new Date(str);
};

$.offsetPosition = function (node, excludeSelf) {
  var x = 0;
  var y = 0;
  if (excludeSelf) node = node.offsetParent;
  while (node && node !== document.body) {
    var position = getComputedStyle(node).position;
    if (position === 'relative' || position === 'absolute' || position === 'fixed' || position === 'sticky') break;
    x += node.offsetLeft;
    y += node.offsetTop;
    node = node.offsetParent;
  }
  return { x: x, y: y };
};

$.fixedPosition = function (node, excludeSelf) {
  var x = 0;
  var y = 0;
  if (excludeSelf) node = node.offsetParent;
  var node1 = node;
  while (node1 && node1 !== document.body) {
    x += node1.offsetLeft;
    y += node1.offsetTop;
    // console.info(992, node1.scrollTop, node1.offsetTop)
    node1 = node1.offsetParent;
  }
  node1 = node;
  while (node1 && node1 !== document.body) {
    if (node1.scrollTop) y -= node1.scrollTop;
    if (node1.scrollLeft) x -= node1.scrollLeft;
    // console.info(992, node1.scrollTop, node1.offsetTop)
    node1 = node1.parentNode;
  }
  // console.info(999, x, y)
  return { x: x, y: y };
};

// let popupInited = false
var popupTargets = [];
// let popupClassName = ''
// let savedOverflow = null
// $.popup = (view, event, direct) => {
//   $.showPopup(view)
//
//   if (!direct) direct = 'right'
//   // let { x, y } = $.offsetPosition(node)
//   // let fixedXY = $.offsetPosition(view, true)
//   // view.style.top = (y - fixedXY.y + node.clientHeight) + 'px'
//   // x -= fixedXY.x
//   // savedOverflow = view.offsetParent.style.overflow
//   // view.offsetParent.style.overflow = 'visible'
//
//   // let subMenuParent = view.offsetParent
//   // if (x + view.clientWidth > subMenuParent.clientWidth) x = subMenuParent.clientWidth - view.clientWidth
//   // view.style.left = x + 'px'
//   let offsetX = 0
//   if (direct === 'left') offsetX = view.clientWidth * -1
//   view.style.left = (event.pageX + offsetX) + 'px'
//   view.style.top = event.pageY + 'px'
// }

window.addEventListener('click', function (event) {
  if (popupTargets.length > 0) {
    var target = event.target;
    var outViews = [];
    var _iteratorNormalCompletion15 = true;
    var _didIteratorError15 = false;
    var _iteratorError15 = undefined;

    try {
      for (var _iterator15 = popupTargets[Symbol.iterator](), _step15; !(_iteratorNormalCompletion15 = (_step15 = _iterator15.next()).done); _iteratorNormalCompletion15 = true) {
        var o = _step15.value;
        outViews.push(o);
      }
    } catch (err) {
      _didIteratorError15 = true;
      _iteratorError15 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion15 && _iterator15.return) {
          _iterator15.return();
        }
      } finally {
        if (_didIteratorError15) {
          throw _iteratorError15;
        }
      }
    }

    while (target) {
      var pos = outViews.indexOf(target);
      if (pos !== -1) {
        outViews.splice(pos, 1);
      }
      target = target.parentNode;
      if (target.nodeName === 'BODY') break;
    }

    for (var i = outViews.length - 1; i >= 0; i--) {
      var view = outViews[i];
      // $.removeClass(view, view.getAttribute('show') || 'd-block')
      $.hide(view);
      popupTargets.splice(popupTargets.indexOf(view), 1);
    }
  }
});

$.showPopup = function (view) {
  // if (popupTargets.length > 0) $.closePopup()
  // let showClass = view.getAttribute('show')
  // if (showClass) {
  //   $.addClass(view, showClass)
  // } else {
  // }
  return new Promise(function (resolve) {
    setTimeout(function () {
      // 延后设置，防止显示的点击事件直接触发关闭
      $.show(view);
      popupTargets.push(view);
      resolve();
    });
  });
  // if (!popupInited) {
  //   // setTimeout(() => {
  //   //
  //   // })
  //   popupInited = true
  // }
};

$.closePopup = function (view) {
  if (!view && popupTargets.length > 0) view = popupTargets[popupTargets.length - 1];
  if (view) {
    // let showClass = view.getAttribute('show')
    // if (showClass) {
    //   $.removeClass(view, showClass)
    // } else {
    $.hide(view);
    // }
    var pos = popupTargets.indexOf(view);
    if (pos !== -1) popupTargets.splice(pos, 1);
  }
};

$.copyToClipBoard = function (content) {
  var dom = document.createElement('textarea');
  dom.style.position = 'absolute';
  dom.style.opacity = '0';
  dom.value = content;
  document.body.appendChild(dom);
  dom.select();
  document.execCommand('copy');
  document.body.removeChild(dom);
};

$.json = function (value, space) {
  try {
    return JSON.stringify(value, null, space);
  } catch (err) {
    return value;
  }
};

$.unJson = function (value) {
  try {
    return JSON.parse(value);
  } catch (err) {
    return value;
  }
};

var storagePrefix = '';
$.storage = {
  init: function init(prefix) {
    storagePrefix = prefix;
  },
  get: function get$$1(key) {
    if (key instanceof Array) {
      var o = {};
      var _iteratorNormalCompletion16 = true;
      var _didIteratorError16 = false;
      var _iteratorError16 = undefined;

      try {
        for (var _iterator16 = key[Symbol.iterator](), _step16; !(_iteratorNormalCompletion16 = (_step16 = _iterator16.next()).done); _iteratorNormalCompletion16 = true) {
          var k = _step16.value;

          o[k] = $.unJson(localStorage[storagePrefix + k]);
        }
      } catch (err) {
        _didIteratorError16 = true;
        _iteratorError16 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion16 && _iterator16.return) {
            _iterator16.return();
          }
        } finally {
          if (_didIteratorError16) {
            throw _iteratorError16;
          }
        }
      }

      return o;
    } else {
      return $.unJson(localStorage[storagePrefix + key]);
    }
  },
  set: function set$$1(key, value) {
    if (typeof key !== 'string') {
      for (var k in key) {
        localStorage[storagePrefix + k] = $.json(key[k]) || '';
      }
    } else {
      localStorage[storagePrefix + key] = $.json(value) || '';
    }
  },
  remove: function remove(key) {
    if (typeof key !== 'string') {
      for (var k in key) {
        localStorage.removeItem(storagePrefix + k);
      }
    } else {
      localStorage.removeItem(storagePrefix + key);
    }
  }
};

function followScrollX(event) {
  if (event.currentTarget.followScrollX) {
    event.currentTarget.followScrollX.scrollLeft = event.currentTarget.scrollLeft;
  }
}

$.fixTable = function (target) {
  if (target) {
    var tables = $.all('table', target);
    if (tables.length === 2) {
      var headerCols = $.all('th, td', tables[0]);
      var bodyCols = $.all('tr:first-child th, tr:first-child td', tables[1]);
      if (headerCols.length && bodyCols.length) {
        for (var i = 0; i < headerCols.length; i++) {
          if (bodyCols[i]) headerCols[i].style.width = getComputedStyle(bodyCols[i]).width;
        }
      }

      // 让表头跟着一起滚动
      if (!tables[1].parentNode.followScrollX) {
        tables[1].parentNode.followScrollX = tables[0].parentNode;
        tables[1].parentNode.addEventListener('scroll', followScrollX);
      }
    }
  }
};

$.fixAllTables = function (from) {
  $.all('.fixedTable', function (target) {
    $.fixTable(target);
  }, from);
};

var windowResizingTask = 0;
var startedFixTable = false;
$.startFixTable = function () {
  if (startedFixTable) return;
  startedFixTable = true;
  window.addEventListener('resize', function (event) {
    if (windowResizingTask) clearTimeout(windowResizingTask);
    windowResizingTask = setTimeout($.fixAllTables, 100);
  });
};

$.findDomAttribute = function (target, attr, parent) {
  if (!parent) parent = document.body;
  while (target && target !== parent) {
    if (target.hasAttribute(attr)) return target.getAttribute(attr);
    target = target.parentNode;
  }
  return '';
};

$.findDomProperty = function (target, property, parent) {
  if (!parent) parent = document.body;
  while (target && target !== parent) {
    if (target[property]) return target[property];
    target = target.parentNode;
  }
  return {};
};

$.findDomByAttribute = function (target, attr, parent) {
  if (!parent) parent = document.body;
  while (target && target !== parent) {
    if (target.hasAttribute(attr)) return target;
    target = target.parentNode;
  }
  return null;
};

$.findDomByProperty = function (target, property, parent) {
  if (!parent) parent = document.body;
  while (target && target !== parent) {
    if (target[property]) return target;
    target = target.parentNode;
  }
  return null;
};

$.findDomByClass = function (target, className, parent) {
  if (!parent) parent = document.body;
  while (target && target !== parent) {
    if ($.hasClass(target, className)) return target;
    target = target.parentNode;
  }
  return '';
};

$.findDomByTagName = function (target, tagName, parent) {
  if (!parent) parent = document.body;
  while (target && target !== parent) {
    if (target.tagName === tagName.toUpperCase()) return target;
    target = target.parentNode;
  }
  return '';
};

$.int = function (v) {
  if (!v) return 0;
  if (typeof v === 'number' || v instanceof Number) return v;
  if ((typeof v === 'undefined' ? 'undefined' : _typeof(v)) === 'object') v = v.toString ? v.toString() : '';
  if (typeof v !== 'string') return 0;
  try {
    return Math.round(parseFloat(v.replace(/,/g, '').trim())) || 0;
  } catch (e) {
    return 0;
  }
};

$.float = function (v) {
  if (!v) return 0.0;
  if (typeof v === 'number' || v instanceof Number) return v;
  if ((typeof v === 'undefined' ? 'undefined' : _typeof(v)) === 'object') v = v.toString ? v.toString() : '';
  if (typeof v !== 'string') return 0.0;
  try {
    return parseFloat(v.replace(/,/g, '').trim()) || 0.0;
  } catch (e) {
    return 0.0;
  }
};

$.str = function (v) {
  if (!v) return '';
  if (typeof v === 'string') return v;
  if (v.toString) return v.toString();
  return '';
};

$.trim = function (v) {
  return $.str(v).trim();
};

var timers = {};
$.timer = function (name, isNew) {
  if (timers[name] && !isNew) return timers[name];
  var timer = {
    name: name,
    startTime: new Date().getTime(),
    trace: function trace(name) {
      var lastTime = new Date().getTime();
      var totalDuration = lastTime - this.startTime;
      var lastDuration = this.lastTime ? lastTime - this.lastTime : totalDuration;
      this.lastTime = lastTime;
      console.info('###', this.name, name, lastDuration, '/', totalDuration);
    }
  };
  timers[name] = timer;
  console.info('###', name, 0);
  return timer;
};

function _setVarsValue(vars, value, datas) {
  var data = datas;
  for (var i = 0; i < vars.length - 1; i++) {
    data = data[vars[i]];
    if (!data) return;
  }
  data[vars[vars.length - 1]] = value;
}

function makeString(str, datas, thisArg) {
  var str1 = str;

  // // 处理动态属性
  // let p1 = str.indexOf('[')
  // let p2 = str.indexOf(']')
  // if (p1 !== -1 && p2 !== -1 && p2 > p1) {
  //   // 预处理循环中的动态变量
  //   str = str.replace(/\[[^\[]+?]/g, word => {
  //     console.info('===', str, word)
  //     let r = makeString('{' + word.substring(1, word.length - 1) + '}', datas)
  //     if (!r) {
  //       console.info('  ===1', word)
  //       return word
  //     }
  //     if (/^\d+$/.test(r)) {
  //       console.info('  ===2', '[' + r + ']')
  //       return '[' + r + ']'
  //     }
  //     console.info('  ===3', '.' + r)
  //     return '.' + r
  //   })
  // }

  // if (s1.indexOf('!r.isHeader?') !== -1) console.info('        .1', str)
  // if (str1.indexOf("!='table'") !== -1) console.info('        ====1', str)
  if (str.indexOf('{') !== -1) {
    str = makeStringOnce(str, datas, thisArg);
  }
  // if (s1.indexOf('!r.isHeader?') !== -1) console.info('        .2', str)
  // if (str1.indexOf("!='table'") !== -1) console.info('        ====2', str)

  // if (s1.indexOf('依赖') !== -1) console.info('  >', str)
  if (str.indexOf('{') !== -1) {
    str = makeStringOnce(str, datas, thisArg);
  }
  // if (str1.indexOf("!='table'") !== -1) console.info('        ====3', str)

  // if (s1.indexOf('依赖') !== -1) console.info('    >', str)
  if (str.indexOf('{') !== -1) {
    str = makeStringOnce(str, datas, thisArg);
  }

  if (str.indexOf('__TEMP_NMT_TAG__') !== -1) str = str.replace(/__TEMP_NMT_TAG__/g, '{');
  // if (s1.indexOf('依赖') !== -1) console.info('      >', str)
  // if (str1.indexOf("!='table'") !== -1) console.info('        ====4', str)

  return str;
}

function makeStringOnce(str, datas, thisArg) {
  var args = ['$'];
  var values = [$];
  for (var key in datas) {
    args.push(key);
    values.push(datas[key]);
  }
  var lastArgsIndex = args.length;
  args.push('return null');

  var str1 = str;
  // if(str1.indexOf("!='table'") !== -1) console.info(111,str)
  str = str.replace(/\{([^{]*?)\}/g, function (full, part1) {
    // if (str1.indexOf("!='table'") !== -1) console.info(111.5, part1)
    if (!part1) return '';
    if (part1[0] === '^') return '__TEMP_NMT_TAG__' + part1.substring(1) + '}';

    var matchLanguage = part1[0] === '&';
    // console.info(' >0', matchLanguage, part1)
    if (matchLanguage) part1 = part1.substring(1);
    try {
      var noMoreTry = part1[0] === '#';
      if (noMoreTry) part1 = part1.substring(1);
      args[lastArgsIndex] = 'return ' + part1;
      var func = Function.constructor.apply(null, args);
      var result = func.apply(thisArg || null, values);
      // if (str1.indexOf("!='table'") !== -1) console.info(' =>', args, result)
      // console.info('  >1', matchLanguage, result)
      if (result === undefined || result === null) return '';
      if (noMoreTry && result.indexOf('{') !== -1 && result.indexOf('}') !== -1) {
        result = result.replace(/\{/g, '__TEMP_NMT_TAG__');
      }
      if (matchLanguage) {
        // console.info('   >2', matchLanguage, result)
        if ($.lang && $.lang[result]) {
          result = $.lang[result];
        }
      }
      return result;
    } catch (err) {
      // if(str1.indexOf("!='table'") !== -1) console.error(str, err)
      // console.error(str, err)
      // return full
      if (part1.indexOf('.') !== -1) part1 = ''; // 变量找不到返回空

      if (matchLanguage) {
        if ($.lang && $.lang[part1]) {
          part1 = $.lang[part1];
        }
      }
      return part1;
    }
  });
  // if(str1.indexOf("||'label'") !== -1) console.info(222,str)

  // console.info(222, str, args)
  return str;
}

function splitVar(v) {
  if (v.indexOf('[\'')) {
    v = v.replaceAll('\']', '');
    v = v.replaceAll('[\'', '.');
  }
  if (v.indexOf('[')) {
    v = v.replaceAll(']', '');
    v = v.replaceAll('[', '.');
  }
  return v.split('.');
}

function renderAction(event) {
  var _this = this;

  // if (!renderBox.renderRowHeight) renderBox.renderRowHeight = renderBox.renderChilds.length ? renderBox.scrollHeight / renderBox.renderChilds.length : 30
  // console.info('>> #', renderBox.scrollHeight, renderBox.renderChilds.length, renderBox.scrollHeight / renderBox.renderChilds.length)
  // console.info('>> ^', render.box, renderBox.renderChilds)
  // $.timer('渲染').trace('开始计算')
  // let t1 = new Date().getTime()
  // let rrr = Math.floor(Math.random() * 100000).toString(36)
  // console.info(rrr, 111, this.renderTID, this.renderChilds.length, this)
  if (this.renderTID) clearTimeout(this.renderTID);
  this.renderTID = setTimeout(function () {
    // console.info(rrr, 222, this.renderChilds.length)
    _this.renderTID = 0;

    var makeList = [];
    for (var i = 0; i < _this.renderChilds.length; i++) {
      var rowNode = _this.renderChilds[i];
      // console.info("  >>>", i, rowNode.offsetTop, this.scrollTop, this.clientHeight, rowNode.offsetTop, this.scrollTop - this.clientHeight)
      if (rowNode.offsetTop >= _this.scrollTop - _this.clientHeight) {
        if (!rowNode.renderMade) {
          rowNode.renderMade = true;
          makeList.push(rowNode);
        }
      }
      // console.info("    >>>>>", i, rowNode.offsetTop, this.scrollTop, this.clientHeight, rowNode.offsetTop >= this.scrollTop, this.clientHeight * 2)
      if (rowNode.offsetTop >= _this.scrollTop + _this.clientHeight * 2) {
        // console.info(' >> $', i, rowNode.offsetTop, '>=', this.scrollTop + this.clientHeight * 2, '|', this.scrollTop, '+', this.clientHeight, '* 2')
        break;
      }
    }
    // console.info(makeList.length)
    // let t2 = new Date().getTime()
    // console.info('    >>>>>>>>>>>>>>>>====------------>2', t2 - t1)

    // $.timer('渲染').trace('开始生成'+makeList.length)
    // let t9 = 0
    // let t9c = 0
    var isAsync = _this.renderChilds.length > 100;
    // console.info(rrr,333, makeList.length, isAsync)
    if (makeList.length > 0) {
      // _make(makeList, this.datas, level + 1, dataFields, this.thisArg, {})

      if (isAsync) {
        var _loop = function _loop(_i) {
          var start = _i;
          var end = Math.min(_i + 10, makeList.length);
          // setTimeout((thatRowNode, thatDatas) => {
          //   refresh(thatRowNode, thatDatas, this.thisArg)
          //   thatRowNode.style.visibility = 'visible'
          // }, 0, rowNode, $.copy(this.datas))
          // console.info(rrr,444.1, makeList.length, isAsync)
          setTimeout(function () {
            // console.info(rrr,444.2, start, end)
            for (var j = start; j < end; j++) {
              var _rowNode = makeList[j];

              if (_rowNode.data) {
                for (var k in _rowNode.data) {
                  _this.datas[k] = _rowNode.data[k];
                }
              }
              refresh(_rowNode, _this.datas, _this.thisArg);
              _rowNode.style.visibility = 'visible';
            }
          }, 0);

          // if (rowNode.data) {
          //   for (let k in rowNode.data) {
          //     this.datas[k] = rowNode.data[k]
          //   }
          // }
        };

        for (var _i = 0; _i < makeList.length; _i += 10) {
          _loop(_i);
        }
      } else {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = makeList[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var _rowNode2 = _step.value;

            // console.info(rrr,555.1, makeList.length, rowNode)
            if (_rowNode2.data) {
              for (var k in _rowNode2.data) {
                _this.datas[k] = _rowNode2.data[k];
              }
            }
            refresh(_rowNode2, _this.datas, _this.thisArg);
            _rowNode2.style.visibility = 'visible';
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }
      // console.info(3333, this.renderRowEventTarget, this.thisArg)

      setTimeout(function () {
        var eventNodes = [];
        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = makeList[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var _rowNode3 = _step2.value;

            if (_this.renderRowEvent) {
              eventNodes.push.apply(eventNodes, toConsumableArray($.all('[events]', _rowNode3)));
            }
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }

        if (eventNodes.length > 0) {
          makeEvents(eventNodes, _this.renderRowEventTarget);
        }
      });
    }
    // let t3 = new Date().getTime()
    // console.info('    >>>>>>>>>>>>>>>>====------------>3', t3 - t2, t9c, t9)

    // $.timer('渲染').trace('完成')
    // console.info(event)
    // console.info(this.renderChilds.length, event.currentTarget.scrollTop, event.currentTarget.clientHeight)
    // TODO 根据滚轮滚动对数据进行重新定位和渲染
  }, 30);
}

function _make(nodes, datas, level, dataFields, thisArg, render) {
  if (!level) level = 0;
  if (!dataFields) dataFields = [];
  if (!(nodes instanceof Array)) {
    var targetNode = nodes;
    nodes = [];
    var _iteratorNormalCompletion3 = true;
    var _didIteratorError3 = false;
    var _iteratorError3 = undefined;

    try {
      for (var _iterator3 = targetNode.childNodes[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
        var node = _step3.value;

        nodes.push(node);
      }
    } catch (err) {
      _didIteratorError3 = true;
      _iteratorError3 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion3 && _iterator3.return) {
          _iterator3.return();
        }
      } finally {
        if (_didIteratorError3) {
          throw _iteratorError3;
        }
      }
    }
  }

  if (!render) render = {};
  render = {
    box: render.box,
    // parent: render.parent,
    row: render.row

    // let t1 = new Date().getTime()
    // if(nodes.length>1000) {
    //   console.info(' ====>1', t1, nodes)
    // }
    // let aaa1 = 0
  };var _iteratorNormalCompletion4 = true;
  var _didIteratorError4 = false;
  var _iteratorError4 = undefined;

  try {
    var _loop2 = function _loop2() {
      var node = _step4.value;

      if (!node) return 'continue';
      if (node.isTplMaked) {
        node.parentElement.removeChild(node);
        return 'continue';
      }

      if (node.isRenderRow && !render.box && node.renderBox) {
        // console.info('node.isRenderRow', node, node.isRenderRow, render.box, node.renderBox, $.json(render))
        render.box = node.renderBox;
        render.box.renderChilds = [];
      }

      // if(aaa1 === 0 && nodes.length>1000) {
      //   aaa1 = 1
      //   let t2 = new Date().getTime()
      //   console.info('    ====>1.5', t2 - t1)
      // }

      // 初始化动态dom
      if (node.tagName === 'DOM') {
        var cdom = document.createComment('');
        cdom.domFrom = node.innerText;
        cdom.attributes = node.attributes;
        cdom.parentTagName = node.parentElement.tagName;
        node.parentElement.insertBefore(cdom, node);
        node.parentElement.removeChild(node);
        node = cdom; // 让下面可以立刻处理
      }

      // 动态渲染节点
      var isRendingRow = false;
      var isRenderRow = false;
      if (render.row) {
        isRendingRow = true;
      } else {
        // 动态渲染行
        if (render.box) {
          // if (node.hasAttribute && node.hasAttribute('renderParent')) {
          //   // node.renderBox = render.box
          //   render.parent = node
          // }
          if (node.isRenderRow || node.hasAttribute && node.hasAttribute('renderRow')) {
            // console.info('********', node.isRenderRow, node.hasAttribute && node.hasAttribute('renderRow'), node)
            node.isRenderRow = true;
            node.renderBox = render.box;
            isRenderRow = true;
            // console.info('isRenderRow', node)
            // setTimeout(() => {
            //   render.box.renderTopOffset = render.parent ? render.parent.offsetTop : 0
            //   // console.info('    >>1', render.parent.offsetTop)
            // })
            // render.box.renderRowHeight = node.getAttribute('renderRowHeight') || 30
            // render.box.renderCount = node.getAttribute('renderCount') || 30
            // console.info('  >>1', render.box.renderTopOffset, node.clientHeight, node.getAttribute('renderRowHeight'))
            // node.renderBox.renderChilds.push(node)
            render.row = node;
            if (render.box.renderRowEvent === undefined) render.box.renderRowEvent = !!$('[events]', node);
          }
        }

        // 动态渲染容器
        if (node.isRenderBox || node.hasAttribute && node.hasAttribute('renderBox')) {
          node.isRenderBox = true;
          var renderBox = node;
          renderBox.renderRowEventTarget = thisArg;
          render.box = renderBox;
          renderBox.renderChilds = [];
          if (renderBox.renderAction) {
            renderBox.removeEventListener('scroll', renderBox.renderAction);
          }

          // let renderAction = event => {
          //   // if (!renderBox.renderRowHeight) renderBox.renderRowHeight = renderBox.renderChilds.length ? renderBox.scrollHeight / renderBox.renderChilds.length : 30
          //   // console.info('>> #', renderBox.scrollHeight, renderBox.renderChilds.length, renderBox.scrollHeight / renderBox.renderChilds.length)
          //   // console.info('>> ^', render.box, renderBox.renderChilds)
          //   // $.timer('渲染').trace('开始计算')
          //   // let t1 = new Date().getTime()
          //   if (this.renderTID !== 0) clearTimeout(this.renderTID)
          //   this.renderTID = setTimeout(() => {
          //     this.renderTID = 0
          //
          //     let makeList = []
          //     for (let i = 0; i < renderBox.renderChilds.length; i++) {
          //       let rowNode = renderBox.renderChilds[i]
          //       if (rowNode.offsetTop >= renderBox.scrollTop - renderBox.clientHeight) {
          //         if (!rowNode.renderMade) {
          //           rowNode.renderMade = true
          //           makeList.push(rowNode)
          //         }
          //       }
          //       if (rowNode.offsetTop >= renderBox.scrollTop + renderBox.clientHeight * 2) {
          //         // console.info(' >> $', i, rowNode.offsetTop, '>=', renderBox.scrollTop + renderBox.clientHeight * 2, '|', renderBox.scrollTop, '+', renderBox.clientHeight, '* 2')
          //         break
          //       }
          //     }
          //     // console.info(makeList.length)
          //     // let t2 = new Date().getTime()
          //     // console.info('    >>>>>>>>>>>>>>>>====------------>2', t2 - t1)
          //
          //     // $.timer('渲染').trace('开始生成'+makeList.length)
          //     // let t9 = 0
          //     // let t9c = 0
          //     if (makeList.length > 0) {
          //       // _make(makeList, datas, level + 1, dataFields, thisArg, {})
          //       // console.info(makeList)
          //       let eventNodes = []
          //       for (let rowNode of makeList) {
          //         if (rowNode.data) {
          //           for (let k in rowNode.data) {
          //             datas[k] = rowNode.data[k]
          //           }
          //         }
          //         // console.info(rowNode, datas, thisArg)
          //         // let tt1 = new Date().getTime()
          //         setTimeout(() => {
          //           refresh(rowNode, datas, thisArg)
          //           rowNode.style.visibility = 'visible'
          //         })
          //         // let tt2 = new Date().getTime()
          //         // t9 += tt2 - tt1
          //         // t9c++
          //         // console.info('  >> visible', rowNode)
          //       }
          //       // console.info(3333, renderBox.renderRowEventTarget, thisArg)
          //       setTimeout(() => {
          //         for (let rowNode of makeList) {
          //           if (renderBox.renderRowEvent) {
          //             eventNodes.push(...$.all('[events]', rowNode))
          //           }
          //         }
          //         if (eventNodes.length > 0) {
          //           makeEvents(eventNodes, renderBox.renderRowEventTarget)
          //         }
          //       })
          //     }
          //     // let t3 = new Date().getTime()
          //     // console.info('    >>>>>>>>>>>>>>>>====------------>3', t3 - t2, t9c, t9)
          //
          //     // $.timer('渲染').trace('完成')
          //     // console.info(event)
          //     // console.info(renderBox.renderChilds.length, event.currentTarget.scrollTop, event.currentTarget.clientHeight)
          //     // TODO 根据滚轮滚动对数据进行重新定位和渲染
          //   }, 100)
          //
          // }
          renderBox.renderAction = renderAction;
          renderBox.datas = datas;
          renderBox.thisArg = thisArg;
          renderBox.addEventListener('scroll', renderAction);
          // let t1 = new Date().getTime()
          setTimeout(function () {
            // let t2 = new Date().getTime()
            // console.info('    ====------------>2', t2 - t1)
            // renderAction({ currentTarget: renderBox })
            renderBox.renderAction();
            // let t3 = new Date().getTime()
            // console.info('    ====------------>3', t3 - t2)
          });
        }
      }

      // 初始化循环和条件
      if (node.attributes && (node.attributes.each || node.attributes['if'])) {
        var which = node.attributes.each ? 'each' : 'if';
        var _cdom = document.createComment('');
        if (node.attributes.each) {
          _cdom.eachs = { index: 'index', item: 'item', items: ''
            // let eachs = node.getAttribute('each').split(/\s*,\s*|\s+in\s+/i).reverse()
          };var eachs = [];
          var a = node.getAttribute('each').split(/\s+in\s+/i);
          if (a.length === 1) {
            eachs.push(a[0]);
          } else if (a.length === 2) {
            eachs = a[0].split(/\s*,\s*/i).reverse();
            eachs.unshift(a[1]);
          }
          // console.info(77, eachs)
          var eachVar = eachs[0];
          _cdom.eachs.items = eachVar;
          if (eachs.length > 1) _cdom.eachs.item = eachs[1];
          if (eachs.length > 2) _cdom.eachs.index = eachs[2];
        } else {
          _cdom['ifs'] = node.getAttribute('if');
        }
        node.removeAttribute(which);
        _cdom.htmlTpl = node.outerHTML;
        _cdom.parentTagName = node.parentElement.tagName;
        node.parentElement.insertBefore(_cdom, node);
        node.parentElement.removeChild(node);
        if (node.isRenderBox) _cdom.isRenderBox = node.isRenderBox;
        if (node.isRenderRow) _cdom.isRenderRow = node.isRenderRow;
        if (node.renderBox) _cdom.renderBox = node.renderBox;
        node = _cdom; // 让下面可以立刻处理
      }

      // 初始化属性
      if (node.vars === undefined) {
        node.vars = false;
        var vars = {};
        if (node.attributes) {
          // 待处理列表
          // for (let attr of node.attributes) {
          // for (let i in node.attributes) {
          var attrs = [];
          for (var i = 0; i < node.attributes.length; i++) {
            attrs.push(node.attributes[i]);
          }
          for (var _i2 = 0; _i2 < attrs.length; _i2++) {
            var attr = attrs[_i2];
            if (attr.value && attr.value.indexOf('{') !== -1 && attr.value.indexOf('}') !== -1) {
              if (attr.name === 'class') {
                vars['className'] = attr.value;
                node.className = '';
              } else if (attr.name === 'disabled' || attr.name === 'checked' || attr.name === 'selected' || attr.name === 'readonly' || attr.name === 'required') {
                var attrName = attr.name;
                if (attr.name === 'readonly') attrName = 'readOnly';
                vars[attrName] = attr.value;
                node.removeAttribute(attr.name);
              } else if (attr.name[0] === '_') {
                vars[attr.name.substr(1)] = attr.value;
                node.setAttribute(attr.name.substr(1), '');
                node.removeAttribute(attr.name);
              } else {
                vars[attr.name] = attr.value;
                node.setAttribute(attr.name, '');
              }
              if (!node.vars) node.vars = vars;
            }
          }
        }

        // 处理 TextNode
        if (node.data && typeof node.data === 'string' && node.data.indexOf('{') !== -1 && node.data.indexOf('}') !== -1) {
          vars['data'] = node.data;
          node.data = '';
          if (!node.vars) node.vars = vars;
        }
      }

      if (isRendingRow && node.style && node.hasAttribute('renderRow')) {
        node.style.visibility = 'hidden';
        // console.info('>> hidden', node)
        // node.rendered = false
        //   tpl.makeEvents(this.$.all('[events]'), this)
        return 'continue';
      }

      // 处理属性
      if (level === 0 && node.getAttribute && node.getAttribute('module')) {
        // module 的第一级不处理（由调用方处理）
      } else {
        makeNodeVars(node, datas, thisArg);
      }
      // if (node.vars) {
      //     for (let key in node.vars) {
      //         let newValue = makeString(node.vars[key], datas)
      //         if (key === 'data') {
      //             let div = document.createElement('div')
      //             div.innerHTML = newValue
      //             node.data = div.innerHTML
      //         }else if (key === 'className') {
      //             node[key] = newValue
      //         } else if (key === 'disabled' || key === 'checked' || key === 'selected') {
      //             node[key] = newValue === 'true' || newValue === '1'
      //         } else {
      //             node.setAttribute(key, newValue)
      //         }
      //     }
      // }

      // 初始化数据绑定 bind
      if (node.binds === undefined) {
        node.binds = false;
        if (node.attributes && node.attributes.bind) {
          var bindVar = node.attributes.bind.value;
          node.bindVar = bindVar;
          node.binds = splitVar(bindVar);

          switch (node.tagName) {
            case 'INPUT':
            case 'TEXTAREA':
            case 'SELECT':
              node.addEventListener('change', function (e) {
                var v = null;
                if (node.tagName === 'SELECT') {
                  v = e.target.options[e.target.selectedIndex].value;
                } else if (node.type === 'checkbox') {
                  if (e.target.checked !== null) {
                    v = e.target.checked;
                  } else {
                    v = e.target.getAttribute('checked') === null;
                  }
                } else if (node.type === 'radio') {
                  if (e.target.checked !== null) {
                    v = e.target.value;
                    e.target.name = bindVar;
                  }
                } else {
                  v = e.target.value;
                }
                if (v !== null) {
                  // if (node.type === 'checkbox') console.info(111, e.target.binds, v, node.bindDatas)
                  _setVarsValue(e.target.binds, v, node.bindDatas);
                  var onbind = e.target.getAttribute('onbind');
                  if (onbind) {
                    var func = Function.constructor.apply(null, [onbind]);
                    func(e);
                  }
                }
              });
              break;
            default:
              // 支持 radio、checkbox
              var bindType = node.getAttribute('bindType');
              if (!bindType) {
                if (node.innerHTML.indexOf('type="radio"') !== -1) {
                  bindType = 'radio';
                } else if (node.innerHTML.indexOf('type="checkbox"') !== -1) {
                  bindType = 'checkbox';
                }
              }

              // let radios = $.all('[type="radio"]', node)
              // let checkboxs = $.all('[type="checkbox"]', node)
              // if (radios.length > 0 || checkboxs.length > 0) {
              // for (let radio of radios) {
              //   radio.checked = radio.value === data
              // }
              // for (let checkbox of checkboxs) {
              //   checkbox.checked = checkbox.value === data
              // }
              if (bindType) {
                node.addEventListener('change', function (e) {
                  if (bindType === 'radio') {
                    _setVarsValue(e.currentTarget.binds, e.target.value, node.bindDatas);
                  } else if (bindType === 'checkbox') {
                    var values = [];
                    $.all('[type="checkbox"]', function (n) {
                      if (n.checked) values.push(n.value);
                    }, node);
                    _setVarsValue(e.currentTarget.binds, values, node.bindDatas);
                  }

                  var onbind = e.currentTarget.getAttribute('onbind');
                  if (onbind) {
                    var func = Function.constructor.apply(null, [onbind]);
                    func(e);
                  }
                });
              }
            // }
          }
        }
      }

      // 处理绑定
      if (node.bindVar) {
        var _bindVar = makePreVars(node.bindVar, datas, false, thisArg);
        if (_bindVar.indexOf('[') !== -1) {
          // 处理有数组的情况
          node.binds = [];
          var _iteratorNormalCompletion5 = true;
          var _didIteratorError5 = false;
          var _iteratorError5 = undefined;

          try {
            for (var _iterator5 = splitVar(_bindVar)[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
              var k = _step5.value;

              if (k.endsWith(']') && k.indexOf('[') !== -1) {
                var _a = k.split('[', 2);
                k = _a[0];
                var index = _a[1].substring(0, _a[1].length - 1);
                node.binds.push(k);
                node.binds.push(index);
              } else {
                node.binds.push(k);
              }
            }
          } catch (err) {
            _didIteratorError5 = true;
            _iteratorError5 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion5 && _iterator5.return) {
                _iterator5.return();
              }
            } finally {
              if (_didIteratorError5) {
                throw _iteratorError5;
              }
            }
          }
        } else {
          node.binds = splitVar(_bindVar);
        }

        // if(node.bindVar.indexOf('{')!==-1)console.info(node.bindVar, bindVar)

        // if (bindVar.indexOf('{') !== -1) {
        //   bindVar = makeString(bindVar, datas)
        // }

        // if (bindVar.indexOf('{') !== -1) {
        //   // console.info(node.attributes.bind.value, datas)
        //   // 处理中括号引用
        //   bindVar = bindVar.replace(/\{.*?}/g, word => {
        //     let r = makeString(word, datas)
        //     return r || ''
        //   })
        //   // console.info('  =>>', bindVar)
        // }
        //
        // if (bindVar.indexOf('[') !== -1) {
        //   // console.info(node.attributes.bind.value, datas)
        //   // 处理中括号引用
        //   bindVar = bindVar.replace(/\[.*?]/g, word => {
        //     // console.info('---', word.substring(1, word.length - 1))
        //     let r = makeString('{' + word.substring(1, word.length - 1) + '}', datas)
        //     return r ? '.' + r : word
        //   })
        //   // console.info('  =>>', bindVar)
        // }

        node.bindDatas = {};
        for (var _k in datas) {
          node.bindDatas[_k] = datas[_k];
        }
        var data = datas;
        var _iteratorNormalCompletion6 = true;
        var _didIteratorError6 = false;
        var _iteratorError6 = undefined;

        try {
          for (var _iterator6 = node.binds[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
            var _k2 = _step6.value;

            data = data[_k2];
            if (!data) break;
          }
        } catch (err) {
          _didIteratorError6 = true;
          _iteratorError6 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion6 && _iterator6.return) {
              _iterator6.return();
            }
          } finally {
            if (_didIteratorError6) {
              throw _iteratorError6;
            }
          }
        }

        if (!data && _bindVar) {
          data = makeString('{' + _bindVar + '}', datas, thisArg);
          // if (!data && nodeBinds.length === 1) {
          //   data = nodeBinds[0]
          // }
          // if(bindVar.indexOf('$')!==-1)console.info(222, bindVar, data)
        }
        switch (node.tagName) {
          case 'INPUT':
          case 'TEXTAREA':
          case 'SELECT':
            if (node.tagName === 'SELECT') {
              var thatNode = node;
              setTimeout(function () {
                var selectedIndex = 0;
                for (var _i3 = 0; _i3 < thatNode.options.length; _i3++) {
                  var o = thatNode.options[_i3];
                  // console.info('===', o.value, data, thatNode.options)
                  if (o.value == data) {
                    selectedIndex = _i3;
                    break;
                  }
                }
                // console.info('  >>>', selectedIndex)
                thatNode.selectedIndex = selectedIndex;
              });
            } else if (node.type === 'checkbox') {
              if (data === true || data === 'true' || data === 1 || data === '1') {
                node.checked = true;
                // node.setAttribute('checked', '')
              } else {
                node.checked = false;
                // node.removeAttribute('checked')
              }
            } else if (node.type === 'radio') {
              if (data == node.value) {
                node.checked = true;
              } else {
                node.checked = false;
              }
            } else {
              node.value = data || '';
            }
            break;
          default:
            var _bindType = node.getAttribute('bindType');
            if (!_bindType) {
              if (node.innerHTML.indexOf('type="radio"') !== -1) {
                _bindType = 'radio';
              } else if (node.innerHTML.indexOf('type="checkbox"') !== -1) {
                _bindType = 'checkbox';
              }
            }

            if (_bindType) {
              // 延后处理，等子节点先渲染好（如循环、判断）
              setTimeout(function () {
                // let isTestNode = $.hasClass(node, 'testNode')
                if (_bindType === 'radio') {
                  var radios = $.all('[type="radio"]', node);
                  // let isTestNode = $.hasClass(node, 'testNode')
                  // if (isTestNode) console.info(11, node.ifs, node.eachs)
                  if (radios.length > 0) {
                    // if (isTestNode) console.info(22)
                    var _iteratorNormalCompletion7 = true;
                    var _didIteratorError7 = false;
                    var _iteratorError7 = undefined;

                    try {
                      for (var _iterator7 = radios[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
                        var radio = _step7.value;

                        radio.checked = radio.value === data;
                      }
                    } catch (err) {
                      _didIteratorError7 = true;
                      _iteratorError7 = err;
                    } finally {
                      try {
                        if (!_iteratorNormalCompletion7 && _iterator7.return) {
                          _iterator7.return();
                        }
                      } finally {
                        if (_didIteratorError7) {
                          throw _iteratorError7;
                        }
                      }
                    }
                  }
                } else if (_bindType === 'checkbox') {
                  var checkboxs = $.all('[type="checkbox"]', node);
                  if (checkboxs.length > 0) {
                    // if (isTestNode) console.info(33)
                    if (!data instanceof Array) data = [data];
                    var _iteratorNormalCompletion8 = true;
                    var _didIteratorError8 = false;
                    var _iteratorError8 = undefined;

                    try {
                      for (var _iterator8 = checkboxs[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
                        var checkbox = _step8.value;

                        checkbox.checked = data.indexOf(checkbox.value) !== -1;
                      }
                    } catch (err) {
                      _didIteratorError8 = true;
                      _iteratorError8 = err;
                    } finally {
                      try {
                        if (!_iteratorNormalCompletion8 && _iterator8.return) {
                          _iterator8.return();
                        }
                      } finally {
                        if (_didIteratorError8) {
                          throw _iteratorError8;
                        }
                      }
                    }
                  }
                }
              });
            } else {
              node.innerHTML = data || '';
            }

          // let radios = $.all('[type="radio"]', node)
          // let isTestNode = $.hasClass(node, 'testNode')
          // if (isTestNode) console.info(11, node.ifs, node.eachs)
          // if (radios.length > 0) {
          //   if (isTestNode) console.info(22)
          //   for (let radio of radios) {
          //     radio.checked = radio.value === data
          //   }
          // } else {
          //   let checkboxs = $.all('[type="checkbox"]', node)
          //   if (checkboxs.length > 0) {
          //     if (isTestNode) console.info(33)
          //     if (!data instanceof Array) data = [data]
          //     for (let checkbox of checkboxs) {
          //       checkbox.checked = data.indexOf(checkbox.value) !== -1
          //     }
          //   } else {
          //     if (isTestNode) console.info(44)
          //     node.innerHTML = data || ''
          //   }
          // }

          // let nodeChildren = node.children
          // if (nodeChildren.length > 0) {
          //   // console.info(nodeBinds, nodeChildren)
          //   node.innerHTML = data || ''
          // } else {
          //   node.innerText = data || ''
          // }

          // let checkboxs = $.all('[type="checkbox"]', node)
          // if(checkboxs){
          //   console.info(nodeBinds, checkboxs)
          // }else{
          //   let radios = $.all('[type="radio"]', node)
          //   if(radios){
          //     console.info(nodeBinds, radios)
          //   }else{
          //     node.innerText = data || ''
          //   }
          // }
        }
      }

      // 不处理SUBVIEW（除第一级）
      if (level > 0) {
        if (node.id && node.id.startsWith('SUBVIEW_')) return 'continue';
        if (node.getAttribute && node.getAttribute('module')) return 'continue';
      }

      // 处理动态dom
      if (node.domFrom) {
        var domHtml = makeString(node.domFrom, datas, thisArg);
        if (domHtml) {
          var dom = document.createElement(node.parentTagName || 'div');
          dom.innerHTML = domHtml;
          _make(dom, datas, level + 1, dataFields, thisArg, render);
          var _iteratorNormalCompletion9 = true;
          var _didIteratorError9 = false;
          var _iteratorError9 = undefined;

          try {
            for (var _iterator9 = dom.children[Symbol.iterator](), _step9; !(_iteratorNormalCompletion9 = (_step9 = _iterator9.next()).done); _iteratorNormalCompletion9 = true) {
              var domItem = _step9.value;

              domItem.firstChild.isTplMaked = true;
              for (var _i4 = 0; _i4 < node.attributes.length; _i4++) {
                var _attr = node.attributes[_i4];
                domItem.setAttribute(_attr.name, _attr.value);
              }
              node.parentElement.insertBefore(domItem, node);
            }
          } catch (err) {
            _didIteratorError9 = true;
            _iteratorError9 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion9 && _iterator9.return) {
                _iterator9.return();
              }
            } finally {
              if (_didIteratorError9) {
                throw _iteratorError9;
              }
            }
          }
        }
      }

      // 处理条件判断
      if (node['ifs']) {
        // let ifs = node['ifs']
        // let ifs = makePreVars(node['ifs'], datas, true)
        var ifs = makePreVars(node['ifs'], datas, false, thisArg);
        // if (node['ifs'].indexOf('依赖') !== -1) console.info(node['ifs'], ifs)
        // .startsWith('{') ? makeString(node['ifs'], datas) : node['ifs']
        // if (ifs.indexOf('{') !== -1) {
        //   // 预处理循环中的动态变量
        //   ifs = ifs.replace(/\{.*?}/g, word => {
        //     return makeString(word, datas) || ''
        //   })
        // }
        //
        // if (ifs.indexOf('[') !== -1) {
        //   // 预处理循环中的动态变量
        //   ifs = ifs.replace(/\[.*?]/g, word => {
        //     let r = makeString('{' + word.substring(1, word.length - 1) + '}', datas)
        //     if (!r) {
        //       return word
        //     }
        //     if (/\d+/.test(r)) {
        //       return '[' + r + ']'
        //     }
        //     return '.' + r
        //   })
        // }

        var r = makeString('{' + ifs + '}', datas, thisArg);
        var isShow = void 0;
        if (r.indexOf('&&') !== -1 || r.indexOf('||') !== -1) {
          // if (node['ifs'].indexOf('标题') !== -1) console.info('  >', node['ifs'], ifs, '【'+r+'】')
          // 处理复杂判断
          var _a2 = r.split('||');
          for (var _i5 in _a2) {
            var b = _a2[_i5].split('&&');
            for (var j in b) {
              b[j] = b[j] && b[j] !== 'false' && b[j] !== '0' && b[j] !== 'undefined' && b[j] !== 'null' ? 'true' : 'false';
            }
            _a2[_i5] = b.join('&&');
          }
          r = _a2.join('||');
          isShow = makeString('{' + r + '}', datas, thisArg);
        } else {
          isShow = r;
        }

        // let isShow = makeString('{' + ifs + '}', datas)
        // if (node['ifs'].indexOf('标题') !== -1) console.info('  >', node['ifs'], ifs, '【'+isShow+'】')
        // if (isShow && isShow.charAt(0) !== '{' && isShow !== 'false' && isShow !== '0' && isShow !== 'undefined' && isShow !== 'null') {
        if (isShow && isShow !== 'false' && isShow !== '0' && isShow !== 'undefined' && isShow !== 'null') {
          var _dom = document.createElement(node.parentTagName || 'div');
          _dom.innerHTML = node.htmlTpl;
          _make(_dom, datas, level + 1, dataFields, thisArg, render);
          _dom.firstChild.isTplMaked = true;
          node.parentElement.insertBefore(_dom.firstChild, node);
          // _make(node.previousSibling, datas)
        }
        return 'continue';
      }

      // 处理循环
      if (node.eachs) {
        if (node.eachs.items) {
          // 根据 items 找到数据
          var eachVars = node.eachs.items.split('||');
          // if (eachVars.length > 1) console.info(111, eachVars)
          var itemsData = [];
          var _iteratorNormalCompletion10 = true;
          var _didIteratorError10 = false;
          var _iteratorError10 = undefined;

          try {
            for (var _iterator10 = eachVars[Symbol.iterator](), _step10; !(_iteratorNormalCompletion10 = (_step10 = _iterator10.next()).done); _iteratorNormalCompletion10 = true) {
              var _eachVar = _step10.value;

              var s1 = _eachVar;
              _eachVar = makePreVars(_eachVar, datas, false, thisArg);
              // if(s1.indexOf('[argName]')!==-1) console.info(s1, '>>', eachVar)
              // if (eachVar.indexOf('[') !== -1) {
              //   // 预处理循环中的动态变量
              //   eachVar = eachVar.replace(/\[.*?]/g, word => {
              //     let r = makeString('{' + word.substring(1, word.length - 1) + '}', datas)
              //     if (!r) {
              //       return ''
              //     }
              //     if (/\d+/.test(r)) {
              //       return '[' + r + ']'
              //     }
              //     return '.' + r
              //   })
              // }

              var findArr = splitVar(_eachVar);
              var findData = datas;
              var _iteratorNormalCompletion12 = true;
              var _didIteratorError12 = false;
              var _iteratorError12 = undefined;

              try {
                for (var _iterator12 = findArr[Symbol.iterator](), _step12; !(_iteratorNormalCompletion12 = (_step12 = _iterator12.next()).done); _iteratorNormalCompletion12 = true) {
                  var itemsA = _step12.value;

                  findData = findData[itemsA];
                  if (findData === undefined) {
                    break;
                  }
                }
                // if (eachVars.length > 1) console.info('  222', findArr, findData, datas['item'])
                // console.info(99, findArr, findData)

                // 处理数字循环
              } catch (err) {
                _didIteratorError12 = true;
                _iteratorError12 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion12 && _iterator12.return) {
                    _iterator12.return();
                  }
                } finally {
                  if (_didIteratorError12) {
                    throw _iteratorError12;
                  }
                }
              }

              if (!findData) {
                if (/^[1-9]\d*$/.test(_eachVar)) _eachVar = '1,' + _eachVar;
                if (/^[0-9]+,[0-9]+$/.test(_eachVar)) {
                  findData = [];
                  var _a3 = _eachVar.split(',');
                  var n1 = parseInt(_a3[0]);
                  var n2 = parseInt(_a3[1]);
                  if (n2 > n1) {
                    for (var _i6 = n1; _i6 <= n2; _i6++) {
                      findData.push(_i6);
                    }
                  } else {
                    for (var _i7 = n1; _i7 >= n2; _i7--) {
                      findData.push(_i7);
                    }
                  }
                }
              }

              if (findData) {
                if (findData instanceof Array) {
                  itemsData = findData;
                } else if ((typeof findData === 'undefined' ? 'undefined' : _typeof(findData)) === 'object') {
                  itemsData = findData;
                } else {
                  itemsData = [findData];
                }
                // console.info('eachVar', eachVar, findData, itemsData)
                break;
              }
            }
          } catch (err) {
            _didIteratorError10 = true;
            _iteratorError10 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion10 && _iterator10.return) {
                _iterator10.return();
              }
            } finally {
              if (_didIteratorError10) {
                throw _iteratorError10;
              }
            }
          }

          if (itemsData) {
            // if (isRenderRow && itemsData.length > render.box.renderCount) {
            //   // 动态渲染超长列表（小于50行不做处理）
            //   // render.box.renderRow = node
            //   render.box.renderData = itemsData
            //   render.box.style.overflowY = 'hidden !important'
            //   render.box.style.overflowX = 'auto !important'
            //   // let parent = render.parent || render.box
            //   // parent.style.height = (render.box.renderRowHeight * itemsData.length) + 'px'
            //   // console.info('  >>2 out eachs', parent.style.height, itemsData)
            //
            //   // 生成可复用对象池
            //   for (let index = 0; index < render.box.renderCount; index++) {
            //     let dom = document.createElement(node.parentTagName || 'div')
            //     dom.innerHTML = node.htmlTpl
            //     datas[node.eachs.index] = index
            //     datas[node.eachs.item] = itemsData[index]
            //     let newDataFields = $.copy(dataFields)
            //     newDataFields.push(node.eachs.index)
            //     newDataFields.push(node.eachs.item)
            //     _make(dom, datas, level + 1, newDataFields, thisArg, render)
            //     dom.firstChild.isTplMaked = true
            //     let newDom = dom.firstChild
            //     node.parentElement.insertBefore(dom.firstChild, node)
            //
            //     // 设置 data
            //     let newDomData = {}
            //     for (let df of newDataFields) {
            //       // console.info(111, df, datas[df])
            //       newDomData[df] = datas[df]
            //     }
            //     newDom.data = newDomData
            //     // console.info('  222', newDomData, newDom.data)
            //
            //     // _make(node.previousSibling, datas)
            //   }
            //
            // } else {
            // 处理数据
            // let laterMakes = [] // TODO 是否必要在这里预先生成30条，剩下的延后生成？或者能够复用组件？
            for (var _index in itemsData) {
              var _dom2 = document.createElement(node.parentTagName || 'div');
              _dom2.innerHTML = node.htmlTpl;
              datas[node.eachs.index] = _index;
              datas[node.eachs.item] = itemsData[_index];
              var newDataFields = $.copy(dataFields);
              newDataFields.push(node.eachs.index);
              newDataFields.push(node.eachs.item);
              // 设置 data
              var newDomData = {};
              var _iteratorNormalCompletion11 = true;
              var _didIteratorError11 = false;
              var _iteratorError11 = undefined;

              try {
                for (var _iterator11 = newDataFields[Symbol.iterator](), _step11; !(_iteratorNormalCompletion11 = (_step11 = _iterator11.next()).done); _iteratorNormalCompletion11 = true) {
                  var df = _step11.value;

                  newDomData[df] = datas[df];
                }

                // 处理节点
                // if(isRenderRow && index > 30){
                //   laterMakes.push([dom, datas, level + 1, newDataFields, thisArg, render])
                // }else{
              } catch (err) {
                _didIteratorError11 = true;
                _iteratorError11 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion11 && _iterator11.return) {
                    _iterator11.return();
                  }
                } finally {
                  if (_didIteratorError11) {
                    throw _iteratorError11;
                  }
                }
              }

              _make(_dom2, datas, level + 1, newDataFields, thisArg, render);
              var newDom = _dom2.firstChild;
              newDom.isTplMaked = true;
              node.parentElement.insertBefore(newDom, node);
              newDom.data = newDomData;
              if (isRenderRow) {
                render.box.renderChilds.push(newDom);
              }
              // }
            }
            // if (isRenderRow) {
            //   render.box.renderRowCount = itemsData.length
            // }
            // }
          }
        }
        // 循环会处理好子对象，不需要在继续
        return 'continue';
      }

      // 事件对象存储index&item
      if (dataFields.length > 0 && node.getAttribute && node.getAttribute('events')) {
        // console.info('===', '['+node.getAttribute('events')+']' , dataFields)
        if (!node.data) node.data = {};
        var _iteratorNormalCompletion13 = true;
        var _didIteratorError13 = false;
        var _iteratorError13 = undefined;

        try {
          for (var _iterator13 = dataFields[Symbol.iterator](), _step13; !(_iteratorNormalCompletion13 = (_step13 = _iterator13.next()).done); _iteratorNormalCompletion13 = true) {
            var _df = _step13.value;

            // console.info('    ===', df, datas[df])
            node.data[_df] = datas[_df];
          }
        } catch (err) {
          _didIteratorError13 = true;
          _iteratorError13 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion13 && _iterator13.return) {
              _iterator13.return();
            }
          } finally {
            if (_didIteratorError13) {
              throw _iteratorError13;
            }
          }
        }
      }

      // 递归处理子集
      _make(node, datas, level + 1, dataFields, thisArg, render);
    };

    for (var _iterator4 = nodes[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
      var _ret2 = _loop2();

      if (_ret2 === 'continue') continue;
    }
    // let t2 = new Date().getTime()
    // if(nodes.length>1000) {
    //   console.info('    ====>2', t2 - t1)
    // }
  } catch (err) {
    _didIteratorError4 = true;
    _iteratorError4 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion4 && _iterator4.return) {
        _iterator4.return();
      }
    } finally {
      if (_didIteratorError4) {
        throw _iteratorError4;
      }
    }
  }
}

function makePreVars(str, datas, isBool, thisArg) {
  var str1 = str;
  // if (str1.indexOf('+') !== -1) console.info('  makePreVars', str, datas)
  // if (str1.indexOf('!item.if') !== -1) console.info('  makePreVars1', str, isBool, $.json(datas.item, 2))
  if (str.indexOf('{') !== -1) {
    // 预处理循环中的动态变量
    str = str.replace(/\{[^{]+?}/g, function (word) {
      var r = makeString(word, datas, thisArg) || '';
      // if (str1.indexOf('!item.if') !== -1) console.info('    >>', word, r, r && r !== 'false' && r !== '0' && r !== 'undefined' && r !== 'null' ? 'true' : 'false')
      return !isBool ? r : r && r !== 'false' && r !== '0' && r !== 'undefined' && r !== 'null' ? 'true' : 'false';
    });
  }
  // if (str1.indexOf('!item.if') !== -1) console.info('  makePreVars2', str)

  if (str.indexOf('[') !== -1) {
    // 预处理循环中的动态变量
    // if (str1.indexOf('+') !== -1) console.info(111,str)
    str = str.replace(/\[[^\[]+?]/g, function (word) {
      var r = makeString('{' + word.substring(1, word.length - 1) + '}', datas, thisArg);
      // if (str1.indexOf('+') !== -1) console.info(222,word, '{' + word.substring(1, word.length - 1) + '}', r)
      // console.info(0, str, r)
      if (!r) {
        // if (str1.indexOf('+') !== -1) console.info(333,str)
        // console.info(111, word)
        return word;
      }
      // if (/^[\-+]?[0-9]\d*$/.test(r)) {
      if (/^[a-zA-Z]/.test(r)) {
        // if (str1.indexOf('+') !== -1) console.info(444,str)
        // console.info(222, '[' + r + ']')
        // return '[' + r + ']'
        return '.' + r; // 数字也可以用这种方式
      } else if (/^[0-9]\d*$/.test(r)) {
        return '[' + r + ']';
      }
      // if (str1.indexOf("!='table'") !== -1) console.info(555,str)
      // console.info(333, '.' + r)
      return '[\'' + r + '\']';
    });
  }
  // if (str1.indexOf("!='table'") !== -1) console.info('  makePreVars3', str)

  if (str.indexOf('{') !== -1) {
    // 预处理循环中的动态变量
    str = str.replace(/\{[^{]+?}/g, function (word) {
      var r = makeString(word, datas, thisArg) || '';
      return !isBool ? r : r && r !== 'false' && r !== '0' && r !== 'undefined' && r !== 'null' ? 'true' : 'false';
    });
  }
  // if (str1.indexOf('!item.if') !== -1) console.info('  makePreVars4', str)

  if (str.indexOf('[') !== -1) {
    // 预处理循环中的动态变量
    str = str.replace(/\[[^\[]+?]/g, function (word) {
      var r = makeString('{' + word.substring(1, word.length - 1) + '}', datas, thisArg);
      // console.info(' ====', str, r)
      if (!r) {
        // console.info(' == 0', word)
        return word;
      }
      // if (/^[\-+]?[1-9]\d*$/.test(r)) {
      if (/^[a-zA-Z]/.test(r)) {
        // console.info(' == 1', '[' + r + ']')
        return '[' + r + ']';
      } else if (/^[0-9]\d*$/.test(r)) {
        return '[' + r + ']';
      }
      // console.info(' == 2', '[' + r + ']')
      return '[\'' + r + '\']';
    });
  }
  // if (str1.indexOf('!item.if') !== -1) console.info('  makePreVars5', str)
  // if (str1.indexOf('!item.if') !== -1) console.info('')

  // if (str1.indexOf('field.key') !== -1) console.info('  >> makePreVars', str1, '=>', str)
  return str;
}

function makeNodeVars(node, datas, thisArg) {
  if (node.vars) {
    for (var key in node.vars) {
      if (key === 'bind') {
        // 绑定对象后续另行处理
        node.setAttribute(key, node.vars[key]);
        continue;
      }
      var newValue = makeString(node.vars[key], datas, thisArg);
      if (key === 'data') {
        var div = document.createElement('div');
        div.innerHTML = newValue;
        // 暂不支持变量中包含html内容
        // if (div.childNodes.length > 1) {
        //     console.info(node.parentNode)
        //     // div.insertBefore()
        // } else
        if (div.childNodes.length === 1 && div.childNodes[0].data) {
          node.data = div.childNodes[0].data;
        } else {
          node.data = newValue;
          // $.clear(node)
          // for(let subNode of div.children){
          //   console.info(111, subNode.nodeType, subNode.nodeName, subNode)
          //   node.appendChild(subNode)
          // }
          // console.info(222, newValue)
        }
      } else if (key === 'className') {
        node[key] = newValue;
      } else if (key === 'disabled' || key === 'checked' || key === 'selected' || key === 'readOnly' || key === 'required') {
        node[key] = newValue === 'true' || newValue === '1';
      } else {
        node.setAttribute(key, newValue);
      }
    }
  }
}

function refresh(node, datas, thisArg) {
  // 仅处理属性
  makeNodeVars(node, datas, thisArg);
  // if (node.vars) {
  //     for (let key in node.vars) {
  //         let newValue = makeString(node.vars[key], datas)
  //         if (key === 'data') {
  //             let div = document.createElement('div')
  //             div.innerHTML = newValue
  //             node.data = div.innerHTML
  //         }else if (key === 'className') {
  //             node[key] = newValue
  //         } else if (key === 'disabled' || key === 'checked' || key === 'selected') {
  //             node[key] = newValue === 'true' || newValue === '1'
  //         } else {
  //             node.setAttribute(key, newValue)
  //         }
  //     }
  // }
  var dataFields = [];
  for (var k in datas) {
    if (k !== 'data') dataFields.push(k);
  }
  _make(node, datas, 0, dataFields, thisArg, {});
  fixSvg(node);
}

function make(targetNode, datas, thisArg) {
  _make([targetNode], datas, 0, [], thisArg, {});
  fixSvg(targetNode);
}

function makeSelf(targetNode, datas, thisArg) {
  makeNodeVars(targetNode, datas, thisArg);
}

function makeSubs(targetNode, datas, thisArg) {
  var a = [];
  var _iteratorNormalCompletion14 = true;
  var _didIteratorError14 = false;
  var _iteratorError14 = undefined;

  try {
    for (var _iterator14 = targetNode.childNodes[Symbol.iterator](), _step14; !(_iteratorNormalCompletion14 = (_step14 = _iterator14.next()).done); _iteratorNormalCompletion14 = true) {
      var node = _step14.value;
      a.push(node);
    }
  } catch (err) {
    _didIteratorError14 = true;
    _iteratorError14 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion14 && _iterator14.return) {
        _iterator14.return();
      }
    } finally {
      if (_didIteratorError14) {
        throw _iteratorError14;
      }
    }
  }

  _make(a, datas, 0, [], thisArg, {});
  fixSvg(targetNode);
}

var _svgCaches = {};
var _svgCaching = {};

function convertSvgNode(to, from) {
  var _iteratorNormalCompletion15 = true;
  var _didIteratorError15 = false;
  var _iteratorError15 = undefined;

  try {
    for (var _iterator15 = from.childNodes[Symbol.iterator](), _step15; !(_iteratorNormalCompletion15 = (_step15 = _iterator15.next()).done); _iteratorNormalCompletion15 = true) {
      var node = _step15.value;

      if (node.nodeType === 1) {
        if (node.nodeName.toLowerCase() === 'style') {
          to.appendChild(node);
        } else {
          var newNode = document.createElementNS('http://www.w3.org/2000/svg', node.nodeName.toLowerCase());
          var _iteratorNormalCompletion16 = true;
          var _didIteratorError16 = false;
          var _iteratorError16 = undefined;

          try {
            for (var _iterator16 = node.attributes[Symbol.iterator](), _step16; !(_iteratorNormalCompletion16 = (_step16 = _iterator16.next()).done); _iteratorNormalCompletion16 = true) {
              var attr = _step16.value;

              newNode.setAttribute(attr.name, attr.value);
            }
          } catch (err) {
            _didIteratorError16 = true;
            _iteratorError16 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion16 && _iterator16.return) {
                _iterator16.return();
              }
            } finally {
              if (_didIteratorError16) {
                throw _iteratorError16;
              }
            }
          }

          to.appendChild(newNode);

          if (node.childNodes.length) {
            convertSvgNode(newNode, node);
          }
        }
      }
    }
  } catch (err) {
    _didIteratorError15 = true;
    _iteratorError15 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion15 && _iterator15.return) {
        _iterator15.return();
      }
    } finally {
      if (_didIteratorError15) {
        throw _iteratorError15;
      }
    }
  }
}

function makeSvg(node, data) {
  var div = document.createElement('div');
  div.innerHTML = data;
  var svg = div.childNodes[0];
  while (node.childNodes.length) {
    node.removeChild(node.childNodes[0]);
  }var _iteratorNormalCompletion17 = true;
  var _didIteratorError17 = false;
  var _iteratorError17 = undefined;

  try {
    for (var _iterator17 = svg.attributes[Symbol.iterator](), _step17; !(_iteratorNormalCompletion17 = (_step17 = _iterator17.next()).done); _iteratorNormalCompletion17 = true) {
      var attr = _step17.value;

      if (node.getAttribute('_' + attr.name)) continue;
      if (attr.name === 'style' && node.hasAttribute('style')) continue;
      node.setAttribute(attr.name, attr.value);
    }
  } catch (err) {
    _didIteratorError17 = true;
    _iteratorError17 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion17 && _iterator17.return) {
        _iterator17.return();
      }
    } finally {
      if (_didIteratorError17) {
        throw _iteratorError17;
      }
    }
  }

  convertSvgNode(node, svg);
}

// 修复 svg
function fixSvg(dom) {
  if (!dom) dom = document.body;
  var nodes = dom.nodeName.toLowerCase() === 'svg' ? [dom] : dom.querySelectorAll('svg[src]');
  var _iteratorNormalCompletion18 = true;
  var _didIteratorError18 = false;
  var _iteratorError18 = undefined;

  try {
    var _loop3 = function _loop3() {
      var node = _step18.value;

      var src = node.getAttribute('src');
      if (src && node.getAttribute('_loadedSrc') !== src) {
        var _iteratorNormalCompletion19 = true;
        var _didIteratorError19 = false;
        var _iteratorError19 = undefined;

        try {
          for (var _iterator19 = node.attributes[Symbol.iterator](), _step19; !(_iteratorNormalCompletion19 = (_step19 = _iterator19.next()).done); _iteratorNormalCompletion19 = true) {
            var attr = _step19.value;

            if (attr.name.startsWith('_')) continue;
            if (!node.getAttribute('_' + attr.name)) node.setAttribute('_' + attr.name, attr.value);
          }
        } catch (err) {
          _didIteratorError19 = true;
          _iteratorError19 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion19 && _iterator19.return) {
              _iterator19.return();
            }
          } finally {
            if (_didIteratorError19) {
              throw _iteratorError19;
            }
          }
        }

        var svgCache = _svgCaches[src];
        if (!svgCache) {
          // 是否正在缓存？
          if (_svgCaching[src]) {
            _svgCaching[src].push(node);
          } else {
            // 获取svg数据
            _svgCaching[src] = [];
            fetch(src).then(function (r) {
              return r.text();
            }).then(function (svgData) {
              var m = svgData.match(new RegExp('<svg.*?>.*?</svg>', 'is'));
              if (m) {
                m[0] = m[0].replace(/<(\w+)([^<]+?)\/>/g, '<$1$2></$1>');
                _svgCaches[src] = m[0];
                makeSvg(node, m[0]);
                if (_svgCaching[src].length > 0) {
                  var _iteratorNormalCompletion20 = true;
                  var _didIteratorError20 = false;
                  var _iteratorError20 = undefined;

                  try {
                    for (var _iterator20 = _svgCaching[src][Symbol.iterator](), _step20; !(_iteratorNormalCompletion20 = (_step20 = _iterator20.next()).done); _iteratorNormalCompletion20 = true) {
                      var pendingNode = _step20.value;

                      makeSvg(pendingNode, m[0]);
                    }
                  } catch (err) {
                    _didIteratorError20 = true;
                    _iteratorError20 = err;
                  } finally {
                    try {
                      if (!_iteratorNormalCompletion20 && _iterator20.return) {
                        _iterator20.return();
                      }
                    } finally {
                      if (_didIteratorError20) {
                        throw _iteratorError20;
                      }
                    }
                  }
                }
              }
              node.setAttribute('_loadedSrc', src);
              if (_svgCaching[src].length > 0) {
                var _iteratorNormalCompletion21 = true;
                var _didIteratorError21 = false;
                var _iteratorError21 = undefined;

                try {
                  for (var _iterator21 = _svgCaching[src][Symbol.iterator](), _step21; !(_iteratorNormalCompletion21 = (_step21 = _iterator21.next()).done); _iteratorNormalCompletion21 = true) {
                    var _pendingNode = _step21.value;

                    _pendingNode.setAttribute('_loadedSrc', src);
                  }
                } catch (err) {
                  _didIteratorError21 = true;
                  _iteratorError21 = err;
                } finally {
                  try {
                    if (!_iteratorNormalCompletion21 && _iterator21.return) {
                      _iterator21.return();
                    }
                  } finally {
                    if (_didIteratorError21) {
                      throw _iteratorError21;
                    }
                  }
                }
              }
            }).catch(function (e) {
              console.error(e);
            });
          }
        } else {
          // 从缓存创建
          makeSvg(node, svgCache);
          node.setAttribute('_loadedSrc', src);
        }
      }
    };

    for (var _iterator18 = nodes[Symbol.iterator](), _step18; !(_iteratorNormalCompletion18 = (_step18 = _iterator18.next()).done); _iteratorNormalCompletion18 = true) {
      _loop3();
    }
  } catch (err) {
    _didIteratorError18 = true;
    _iteratorError18 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion18 && _iterator18.return) {
        _iterator18.return();
      }
    } finally {
      if (_didIteratorError18) {
        throw _iteratorError18;
      }
    }
  }
}

function makeEvents(nodes, target) {
  if (nodes && target) {
    var _iteratorNormalCompletion22 = true;
    var _didIteratorError22 = false;
    var _iteratorError22 = undefined;

    try {
      for (var _iterator22 = nodes[Symbol.iterator](), _step22; !(_iteratorNormalCompletion22 = (_step22 = _iterator22.next()).done); _iteratorNormalCompletion22 = true) {
        var _node = _step22.value;

        // console.info(' >>>0', node.getAttribute('events'))
        // if (node.getAttribute('events') === 'dragover,drop') {
        //   console.info(' >>>1', node.getAttribute('events'), node)
        // }

        // if (node.hasAttribute('events')) {
        //   let events = node.getAttribute('events').split(',')
        //   // console.info(' !!!1 ', node)
        //   // console.info('   !!!2 ', events)
        //   for (let e of events) {
        //     let a = e.split(':')
        //     if (a.length === 1) a.push(a[0])
        //     // console.info('   >> !!!3 ', a[1], target[a[1]])
        //     if (target[a[1]]) {
        //       if (!node.events) node.events = {}
        //       if (!node.events[a[0]]) {
        //         node.events[a[0]] = true
        //         node.addEventListener(a[0], target[a[1]].bind(target), a.length > 2)
        //       }
        //     }
        //   }
        // }

        if (_node.hasAttribute('events')) {
          var events = _node.getAttribute('events').split(',');
          var _iteratorNormalCompletion23 = true;
          var _didIteratorError23 = false;
          var _iteratorError23 = undefined;

          try {
            for (var _iterator23 = events[Symbol.iterator](), _step23; !(_iteratorNormalCompletion23 = (_step23 = _iterator23.next()).done); _iteratorNormalCompletion23 = true) {
              var e = _step23.value;

              e = e.trim();
              if (!e) continue;
              var a = e.split(':');
              if (a.length === 1) a.push(a[0]);
              // if(a[1]==='save2')console.info('   >> !!!3 ', a[1], target[a[1]])

              if (target[a[1]]) {
                if (!_node.events) _node.events = {};
                if (!_node.events[a[0]] || _node.events[a[0]] !== a[1]) {
                  // if(a[1]==='onSubMenu')console.info('~~~onSubMenu', a, target[a[1]], target)
                  if (_node.events[a[0] + 'Func']) _node.removeEventListener(a[0], _node.events[a[0] + 'Func']);
                  var func = target[a[1]].bind(target);
                  _node.events[a[0]] = a[1];
                  _node.events[a[0] + 'Func'] = func;
                  // console.info(a, func)

                  _node.addEventListener(a[0], func, a.length > 2);
                }
              }
            }
          } catch (err) {
            _didIteratorError23 = true;
            _iteratorError23 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion23 && _iterator23.return) {
                _iterator23.return();
              }
            } finally {
              if (_didIteratorError23) {
                throw _iteratorError23;
              }
            }
          }
        }
      }
    } catch (err) {
      _didIteratorError22 = true;
      _iteratorError22 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion22 && _iterator22.return) {
          _iterator22.return();
        }
      } finally {
        if (_didIteratorError22) {
          throw _iteratorError22;
        }
      }
    }
  }
}

var tpl = { refresh: refresh, make: make, makeSelf: makeSelf, makeSubs: makeSubs, makeString: makeString, fixSvg: fixSvg, makeEvents: makeEvents };

var _typeof$1 = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};











var classCallCheck$1 = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass$1 = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var Route = function () {
  function Route() {
    classCallCheck$1(this, Route);

    this.routeUrl = '';
    this._routeHistoryPos = -1;
    this._routeHistories = [];
    this.paths = [];
    this._binds = {};
    this._spaceChars = ['/', '#', '!', '`', '~', '@', '%', '^', '*', ';', '\\', ' '];
  }

  createClass$1(Route, [{
    key: 'go',
    value: function go(url, args) {
      var paths = [];
      var urls = [];
      var currentPaths = this._routeHistoryPos >= 0 ? this._routeHistories[this._routeHistoryPos] : [];

      if (url === 'up') {
        // 向上一级
        if (currentPaths.length > 0) urls = currentPaths.slice(0, currentPaths.length - 1);
      } else if (typeof url === 'string') {
        // url路由
        var space = url.charAt(0);
        if (space === '.') space = url.charAt(1);
        if (space === '.') space = url.charAt(2);
        if (this._spaceChars.indexOf(space) === -1) {
          // 追加模式
          paths = JSON.parse(JSON.stringify(currentPaths));
          urls = [url];
        } else if (url.charAt(0) === '.') {
          // 追加模式
          paths = JSON.parse(JSON.stringify(currentPaths));
          urls = url.split(space);
        } else {
          urls = url.split(space);
        }
      } else if (typeof url === 'number') {
        // 历史路由
        this._routeHistoryPos += url;
        if (this._routeHistoryPos < 0) this._routeHistoryPos = 0;
        if (this._routeHistoryPos > this._routeHistories.length - 1) this._routeHistoryPos = this._routeHistories.length - 1;
        if (this._routeHistoryPos >= 0) urls = this._routeHistories[this._routeHistoryPos];
      } else if (url instanceof Array) {
        // 数组路由
        urls = url;
      }

      var tmpNames = [];
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = paths[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var tmpPath = _step.value;

          tmpNames.push(tmpPath.name);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      var path = null;
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = urls[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var _url = _step2.value;

          if (!_url) continue;
          if (typeof _url === 'string') {
            if (_url === '.') continue;
            if (_url === '..') {
              if (paths.length > 0) {
                paths = paths.slice(0, paths.length - 1);
                // names = names.slice(0, names.length - 1)
                // newUrls = newUrls.slice(0, newUrls.length - 1)
              }
              continue;
            }

            _url = decodeURIComponent(_url);
            path = { args: {} };
            var argsPos = void 0;
            if ((argsPos = _url.indexOf('?')) !== -1) {
              path.name = _url.substr(0, argsPos);
              var argsA = _url.substr(argsPos + 1).split('&');
              var _iteratorNormalCompletion5 = true;
              var _didIteratorError5 = false;
              var _iteratorError5 = undefined;

              try {
                for (var _iterator5 = argsA[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                  var argA = _step5.value;

                  if (!argA) continue;
                  var argPos = argA.indexOf('=');
                  if (argPos !== -1) {
                    path.args[argA.substr(0, argPos)] = argA.substr(argPos + 1);
                  }
                }
              } catch (err) {
                _didIteratorError5 = true;
                _iteratorError5 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion5 && _iterator5.return) {
                    _iterator5.return();
                  }
                } finally {
                  if (_didIteratorError5) {
                    throw _iteratorError5;
                  }
                }
              }
            } else if ((argsPos = _url.indexOf('{')) !== -1) {
              path.name = _url.substr(0, argsPos);
              try {
                path.args = JSON.parse(_url.substr(argsPos));
              } catch (err) {}
            } else {
              path.name = _url;
            }

            // 相同路径的旧节点如果有参数，继承过来
            tmpNames.push(path.name);
            var tmpPathName = tmpNames.join('.');
            // console.log([tmpPathName, paths.length, currentPaths[paths.length]])
            var prevSamePath = currentPaths[paths.length];
            if (prevSamePath && tmpPathName === prevSamePath.pathName && prevSamePath.args) {
              for (var _k in prevSamePath.args) {
                if (!path.args[_k]) path.args[_k] = prevSamePath.args[_k];
              }
            }
          } else {
            path = _url;
          }

          paths.push(path);
        }

        // 附加参数
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      if (path !== null && args && (typeof args === 'undefined' ? 'undefined' : _typeof$1(args)) === 'object') {
        for (var k in args) {
          path.args[k] = args[k];
        }
      }

      // console.log(this.routeUrl);
      if (typeof url !== 'number') {
        if (this._routeHistoryPos < this._routeHistories.length - 1) {
          this._routeHistories = this._routeHistories.slice(0, this._routeHistoryPos + 1);
        }
        this._routeHistories.push(paths);
        if (this._routeHistories.length > 10) {
          this._routeHistories = this._routeHistories.slice(this._routeHistories.length - 11);
        }
        this._routeHistoryPos = this._routeHistories.length - 1;
      }

      var oldUrl = this.routeUrl;
      this.remakeRouteUrl();
      if (this.routeUrl === oldUrl) {
        // 相同的路由不触发事件
        return new Promise(function (resolve) {
          resolve(paths);
        });
      }

      // // 重新计算 pathName、url
      // let newUrls = []
      // let names = []
      // for (let path of paths) {
      //   names.push(path.name)
      //   path.pathName = names.join('.')
      //
      //   path.url = path.name + (Object.getOwnPropertyNames(path.args).length ? JSON.stringify(path.args) : '')
      //   newUrls.push(path.url)
      // }
      // paths.last = path || {name: '', args: '', pathName: '', url: ''}
      //
      // // 寻找一个没出现过的字符作为间隔符
      // let space = '/'
      // let tmpNewUrlString = newUrls.join('')
      // for (let spaceChar of this._spaceChars) {
      //   if (tmpNewUrlString.indexOf(spaceChar) === -1) {
      //     space = spaceChar
      //     break
      //   }
      // }
      // let newUrl = space + newUrls.join(space)
      // if (newUrl === this.routeUrl) return
      // this.routeUrl = newUrl

      var that = this;
      return new Promise(function (resolve, reject) {
        var pendingTargets = []; // 需要回调的对象
        for (var bindKey in that._binds) {
          if (bindKey === '*') {
            // all match
            pendingTargets.push(that._binds[bindKey]);
          } else {
            var partInfo = that._binds[bindKey].partInfo;
            if (partInfo.pos === -1) {
              if (bindKey === paths.last.pathName) {
                pendingTargets.push(that._binds[bindKey]);
              }
            } else {
              if (partInfo.k1 && !partInfo.k2 && paths.last.pathName.startsWith(partInfo.k1) || partInfo.k2 && !partInfo.k1 && paths.last.pathName.endsWith(partInfo.k2) || partInfo.k1 && partInfo.k2 && paths.last.pathName.startsWith(partInfo.k1) && paths.last.pathName.endsWith(partInfo.k2)) {
                pendingTargets.push(that._binds[bindKey]);
              }
            }
          }
        }

        var _iteratorNormalCompletion3 = true;
        var _didIteratorError3 = false;
        var _iteratorError3 = undefined;

        try {
          for (var _iterator3 = pendingTargets[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
            var targets = _step3.value;
            var _iteratorNormalCompletion4 = true;
            var _didIteratorError4 = false;
            var _iteratorError4 = undefined;

            try {
              for (var _iterator4 = targets[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
                var target = _step4.value;

                if (target.func !== null && typeof target.func === 'function') {
                  target.func.call(target.object, paths);
                }
              }
            } catch (err) {
              _didIteratorError4 = true;
              _iteratorError4 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion4 && _iterator4.return) {
                  _iterator4.return();
                }
              } finally {
                if (_didIteratorError4) {
                  throw _iteratorError4;
                }
              }
            }
          }
        } catch (err) {
          _didIteratorError3 = true;
          _iteratorError3 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion3 && _iterator3.return) {
              _iterator3.return();
            }
          } finally {
            if (_didIteratorError3) {
              throw _iteratorError3;
            }
          }
        }

        resolve(paths);
      });
    }

    // 生成URL

  }, {
    key: 'remakeRouteUrl',
    value: function remakeRouteUrl() {
      var paths = this._routeHistories[this._routeHistoryPos];
      this.paths = paths;
      var newUrls = [];
      var names = [];
      var _iteratorNormalCompletion6 = true;
      var _didIteratorError6 = false;
      var _iteratorError6 = undefined;

      try {
        for (var _iterator6 = paths[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
          var path = _step6.value;

          names.push(path.name);
          path.pathName = names.join('.');

          path.url = path.name + (Object.getOwnPropertyNames(path.args).length ? JSON.stringify(path.args) : '');
          newUrls.push(path.url);
          paths.last = path;
        }
      } catch (err) {
        _didIteratorError6 = true;
        _iteratorError6 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion6 && _iterator6.return) {
            _iterator6.return();
          }
        } finally {
          if (_didIteratorError6) {
            throw _iteratorError6;
          }
        }
      }

      if (!paths.last) paths.last = { name: '', args: '', pathName: '', url: ''

        // 寻找一个没出现过的字符作为间隔符
      };var space = '/';
      var tmpNewUrlString = newUrls.join('');
      var _iteratorNormalCompletion7 = true;
      var _didIteratorError7 = false;
      var _iteratorError7 = undefined;

      try {
        for (var _iterator7 = this._spaceChars[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
          var spaceChar = _step7.value;

          if (tmpNewUrlString.indexOf(spaceChar) === -1) {
            space = spaceChar;
            break;
          }
        }
      } catch (err) {
        _didIteratorError7 = true;
        _iteratorError7 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion7 && _iterator7.return) {
            _iterator7.return();
          }
        } finally {
          if (_didIteratorError7) {
            throw _iteratorError7;
          }
        }
      }

      var newUrl = space + newUrls.join(space);
      this.routeUrl = newUrl;
    }

    // 绑定数据变化通知

  }, {
    key: 'bind',
    value: function bind(keyOrKeys, target) {
      if (!(keyOrKeys instanceof Array)) keyOrKeys = [keyOrKeys];
      var bindTarget = {
        object: null,
        func: null,
        keys: keyOrKeys

        // 构建回调对象
      };if (typeof target === 'function') {
        // direct call function
        bindTarget.func = target;
      } else if ((typeof target === 'undefined' ? 'undefined' : _typeof$1(target)) === 'object') {
        // call object's [set or setData]
        if (target['onRoute'] && typeof target['onRoute'] === 'function') {
          bindTarget.object = target;
          bindTarget.func = target['onRoute'];
        }
      }

      var _iteratorNormalCompletion8 = true;
      var _didIteratorError8 = false;
      var _iteratorError8 = undefined;

      try {
        for (var _iterator8 = keyOrKeys[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
          var key = _step8.value;

          if (!this._binds[key]) this._binds[key] = [];
          this._binds[key].push(bindTarget);

          var partInfo = this._binds[key].partInfo;
          if (partInfo === undefined) {
            partInfo = {};
            partInfo.pos = key.indexOf('*');
            if (partInfo.pos !== -1) {
              partInfo.k1 = key.substr(0, partInfo.pos);
              partInfo.k2 = key.substr(partInfo.pos + 1);
            }
            this._binds[key].partInfo = partInfo;
          }
        }
      } catch (err) {
        _didIteratorError8 = true;
        _iteratorError8 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion8 && _iterator8.return) {
            _iterator8.return();
          }
        } finally {
          if (_didIteratorError8) {
            throw _iteratorError8;
          }
        }
      }
    }

    // 取消绑定

  }, {
    key: 'unbind',
    value: function unbind(keyOrKeys, target) {
      if (!(keyOrKeys instanceof Array)) {
        keyOrKeys = [keyOrKeys];
      }
      var jsonKeys = JSON.stringify(keyOrKeys);
      var _iteratorNormalCompletion9 = true;
      var _didIteratorError9 = false;
      var _iteratorError9 = undefined;

      try {
        for (var _iterator9 = keyOrKeys[Symbol.iterator](), _step9; !(_iteratorNormalCompletion9 = (_step9 = _iterator9.next()).done); _iteratorNormalCompletion9 = true) {
          var key = _step9.value;

          var bindTargets = this._binds[key];
          if (bindTargets) {
            for (var i = bindTargets.length - 1; i >= 0; i--) {
              var bindTarget = bindTargets[i];
              if ((bindTarget.object === target || bindTarget.func === target) && JSON.stringify(bindTarget.keys) === jsonKeys) {
                this._binds[key].splice(i, 1);
              }
            }
          }
        }
      } catch (err) {
        _didIteratorError9 = true;
        _iteratorError9 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion9 && _iterator9.return) {
            _iterator9.return();
          }
        } finally {
          if (_didIteratorError9) {
            throw _iteratorError9;
          }
        }
      }
    }
  }]);
  return Route;
}();

function _$$1(selector) {
  return $(selector, this.dom);
}

function _$all$1(selector, callback) {
  return $.all(selector, callback, this.dom);
}

function _makeEvents$1() {
  // console.info(999, this.$.all('[events]'), this)
  tpl.makeEvents(this.$.all('[events]'), this);
}

function setData(data) {
  for (var k in data) {
    this.data[k] = data[k];
  }
  if (this.onSetData) this.onSetData();
  return this.refreshView();
}

function refreshView(target, isMake) {
  var _this = this;

  if (this.onRefresh) this.onRefresh();
  return new Promise(function (resolve) {
    setTimeout(function () {
      if (target) {
        var datas = { data: this.data || {} };
        if (target.data) {
          for (var k in target.data) {
            datas[k] = target.data[k];
          }
        }
        if (isMake) {
          tpl.make(target, datas);
        } else {
          tpl.refresh(target, datas);
        }
      } else {
        tpl.make(this.dom, { data: this.data || {} });
      }
      if (this.makeEvents) this.makeEvents();
      if (this.onRefreshed) this.onRefreshed();
      resolve();
    }.bind(_this), 0);
  });
}

var _modules = {};

var modules = {

  register: function register(name, module) {
    if ((typeof name === 'undefined' ? 'undefined' : _typeof(name)) === 'object') {
      for (var k in name) {
        _modules[k] = name[k];
      }
    } else {
      _modules[name] = module;
    }
  },

  unregister: function unregister(name) {
    delete _modules[name];
  },

  make: function make(target) {
    target.$.all('[module]', function (node) {
      if (!node.getAttribute) return;
      var moduleName = node.getAttribute('module');
      var moduleClassName = moduleName;
      if (moduleName.indexOf(':') !== -1) {
        var a = moduleName.split(':');
        moduleName = a[0];
        moduleClassName = a[1];
      }

      var moduleClass = _modules[moduleClassName];
      if (moduleClass) {
        var module = new moduleClass();

        // 从属性中设置默认data
        for (var k in module.data) {
          var v = node.getAttribute(k);
          if (v) module.data[k] = v;
          if (k === 'title') node.removeAttribute(k);
        }

        // 从调用方获得data
        if (!target.modules) target.modules = {};
        if (!target.modules[moduleName]) target.modules[moduleName] = {};
        if (target.modules[moduleName].data) {
          for (var _k in target.modules[moduleName].data) {
            module.data[_k] = target.modules[moduleName].data[_k];
          }
        }

        // 从调用方获得事件
        if (target.modules[moduleName].event) {
          for (var _k2 in target.modules[moduleName].event) {
            var eventFunc = target.modules[moduleName].event[_k2];
            if (eventFunc instanceof Function) {
              module[_k2] = eventFunc;
            } else if (typeof eventFunc === 'string' && target[eventFunc]) {
              // if(k==='save2')console.info('~~~makeModule', k, eventFunc, target, module)
              module[_k2] = target[eventFunc].bind(target);
            }
          }
        }

        // 取出要替换的dom
        var optionDoms = {};
        $.all('[moduleOption]', function (optionDom) {
          var optionName = optionDom.getAttribute('moduleOption');
          optionDoms[optionName] = optionDom;
        }, node);

        if (target.modules[moduleName].moduleOptions) {
          for (var _k3 in target.modules[moduleName].moduleOptions) {
            var div = document.createElement('div');
            div.innerHTML = target.modules[moduleName].moduleOptions[_k3];
            optionDoms[_k3] = div;
          }
        }

        // 替换dom
        node.innerHTML = module.html;
        for (var optionName in optionDoms) {
          var optionDom = optionDoms[optionName];
          var oldDom = node.querySelector('[moduleOption="' + optionName + '"]');
          if (oldDom) {
            oldDom.parentNode.insertBefore(optionDom, oldDom);
            // 合并属性
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
              for (var _iterator = oldDom.getAttributeNames()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                var _k4 = _step.value;

                if (_k4 === 'moduleoption') {
                  // 忽略
                } else if (_k4 === 'class') {
                  // 合并样式
                  var a1 = optionDom.className ? optionDom.className.split(/\s+/) : [];
                  var a2 = oldDom.className.split(/\s+/);
                  var _iteratorNormalCompletion2 = true;
                  var _didIteratorError2 = false;
                  var _iteratorError2 = undefined;

                  try {
                    for (var _iterator2 = a2[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                      var cls = _step2.value;

                      if (a1.indexOf(cls) === -1) {
                        a1.push(cls);
                      }
                    }
                  } catch (err) {
                    _didIteratorError2 = true;
                    _iteratorError2 = err;
                  } finally {
                    try {
                      if (!_iteratorNormalCompletion2 && _iterator2.return) {
                        _iterator2.return();
                      }
                    } finally {
                      if (_didIteratorError2) {
                        throw _iteratorError2;
                      }
                    }
                  }

                  optionDom.className = a1.join(' ');
                } else if (_k4 === 'style') {
                  // 拼接样式
                  optionDom.setAttribute(_k4, (optionDom.hasAttribute(_k4) ? optionDom.getAttribute(_k4) + ';' : '') + oldDom.getAttribute(_k4));
                } else {
                  if (!optionDom.hasAttribute(_k4)) optionDom.setAttribute(_k4, oldDom.getAttribute(_k4));
                }
              }
            } catch (err) {
              _didIteratorError = true;
              _iteratorError = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }
              } finally {
                if (_didIteratorError) {
                  throw _iteratorError;
                }
              }
            }

            oldDom.parentNode.removeChild(oldDom);
          }
        }
        module.dom = node;
        module.$ = _$$1.bind(module);
        module.$.all = _$all$1.bind(module);
        module.makeEvents = _makeEvents$1.bind(module);
        module.setData = setData.bind(module);
        module.refreshView = refreshView.bind(module);

        tpl.makeSubs(module.dom, { data: module.data });
        if (module.onCreate) module.onCreate();

        target.modules[moduleName] = module;
      }
    });
  }

};

/*
global location
global XMLHttpRequest
 */

function _$(selector) {
  var subViewId = this.parentPathName ? '#SUBVIEW_' + this.parentPathName.replace(/\./, '_') : '#SUBVIEW_ROOT';
  return $(selector, document.querySelector(subViewId));

  var nodes = this.$.all(selector);
  // console.info(selector, nodes)
  if (nodes.length > 0) return nodes[0];
  return document.querySelector(subViewId);
}

function _filterNodes(nodes, from) {
  // 在路由中排除SUBVIEW和module
  var fixedNodes = [];
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = nodes[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var node = _step.value;

      if (_isValidNode(node, from)) fixedNodes.push(node);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return fixedNodes;
}

function _isValidNode(node, from) {
  // 判断node是否在SUBVIEW和module中
  var findNode = node;
  while (findNode && findNode !== from) {
    // console.info((findNode.id && findNode.id.startsWith('SUBVIEW_')), '|', findNode.hasAttribute('module'), '|', findNode)
    if (findNode.id && findNode.id.startsWith('SUBVIEW_') || findNode !== node && findNode.hasAttribute('module')) {
      return false;
    }
    findNode = findNode.parentNode;
  }
  return true;
}

function _$all(selector, callback) {
  var subViewId = this.parentPathName ? '#SUBVIEW_' + this.parentPathName.replace(/\./, '_') : '#SUBVIEW_ROOT';
  var from = document.querySelector(subViewId);
  if (callback && callback instanceof Function) {
    var realCallback = callback;
    callback = function callback(node) {
      if (_isValidNode(node, from)) {
        realCallback(node);
      }
    };
  }
  var nodes = $.all(selector, callback, from);
  if (!callback) nodes = _filterNodes(nodes, from);
  return nodes;
}

function _moveNodes(to, from) {
  while (from.childNodes.length > 0) {
    to.appendChild(from.childNodes[0]);
  }
}

function _go(path, args) {
  if (path.startsWith('/')) {
    return this.route.go(path, args);
  } else {
    var urls = $.copy(this.urls);
    var a = path.split('/');
    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
      for (var _iterator2 = a[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
        var p = _step2.value;

        if (p === '..') {
          urls.splice(urls.length - 1, 1);
        } else if (p !== '.') {
          urls.push(p);
        }
      }
    } catch (err) {
      _didIteratorError2 = true;
      _iteratorError2 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion2 && _iterator2.return) {
          _iterator2.return();
        }
      } finally {
        if (_didIteratorError2) {
          throw _iteratorError2;
        }
      }
    }

    return this.route.go(urls, args);
  }
}

function _setData(values, onlySelf) {
  var routeChanged = false;
  var path = null;
  for (var key in values) {
    this.data[key] = values[key];
    // 绑定的参数反向同步到路由
    if (this.routeBinds && this.routeBinds.indexOf(key) !== -1) {
      // 查找当前路由节点
      if (path === null) {
        var _iteratorNormalCompletion3 = true;
        var _didIteratorError3 = false;
        var _iteratorError3 = undefined;

        try {
          for (var _iterator3 = this.route._routeHistories[this.route._routeHistoryPos][Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
            var p = _step3.value;

            if (p.pathName === this.pathName) {
              path = p;
            }
          }
        } catch (err) {
          _didIteratorError3 = true;
          _iteratorError3 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion3 && _iterator3.return) {
              _iterator3.return();
            }
          } finally {
            if (_didIteratorError3) {
              throw _iteratorError3;
            }
          }
        }
      }
      // 比较数据是否变更
      if (path) {
        if (path.args[key] !== this.data[key]) {
          path.args[key] = this.data[key];
          routeChanged = true;
        }
      }
    }

    // 数据变化后反向同步到路由
    if (routeChanged) {
      this.route.remakeRouteUrl();
      location.hash = '#' + this.route.routeUrl;
      if (!onlySelf) this.route.makeRoute();
    }
  }

  return this.refreshView();
}

function _getViewByName(name) {
  var path = $.getBy(this.route.paths, 'pathName', name);
  if (!path) path = $.getBy(this.route.paths, 'name', name);
  if (path) {
    return window._cachedViews[path.pathName];
  }
  return null;
}

function _getParentView() {
  var pos = $.indexBy(this.route.paths, 'pathName', this.pathName);
  if (pos !== -1 && pos > 0) {
    return window._cachedViews[this.route.paths[pos - 1].pathName];
  }
  return null;
}

function _getNextView() {
  var pos = $.indexBy(this.route.paths, 'pathName', this.pathName);
  if (pos !== -1 && this.route.paths.length > pos + 1) {
    return window._cachedViews[this.route.paths[pos + 1].pathName];
  }
  return null;
}

function _refreshView(target, isMake) {
  var _this = this;

  return new Promise(function (resolve, reject) {
    var refreshViewCallbacks = [];
    refreshViewCallbacks.push([resolve, reject]);
    setTimeout(function () {
      try {
        var datas = this.datas || {};
        datas.data = this.data;

        if (target) {
          var data = $.findDomProperty(target, 'data', this.dom);
          if (data) {
            for (var k in data) {
              datas[k] = data[k];
            }
          }
          var keepDisplay = getComputedStyle(target).display;
          if (isMake) {
            tpl.make(target, datas, this);
          } else {
            tpl.refresh(target, datas, this);
          }
          if (keepDisplay) target.style.display = keepDisplay;
        } else {
          tpl.make(this.$(), datas, this);
        }
        var _iteratorNormalCompletion4 = true;
        var _didIteratorError4 = false;
        var _iteratorError4 = undefined;

        try {
          for (var _iterator4 = refreshViewCallbacks[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
            var callbacks = _step4.value;

            callbacks[0]();
          }
        } catch (err) {
          _didIteratorError4 = true;
          _iteratorError4 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion4 && _iterator4.return) {
              _iterator4.return();
            }
          } finally {
            if (_didIteratorError4) {
              throw _iteratorError4;
            }
          }
        }

        if (this.makeEvents) this.makeEvents();
        if (this.onRefreshed) this.onRefreshed(target, isMake);
      } catch (err) {
        console.error(err);
        var _iteratorNormalCompletion5 = true;
        var _didIteratorError5 = false;
        var _iteratorError5 = undefined;

        try {
          for (var _iterator5 = refreshViewCallbacks[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
            var _callbacks = _step5.value;

            _callbacks[1](err);
          }
        } catch (err) {
          _didIteratorError5 = true;
          _iteratorError5 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion5 && _iterator5.return) {
              _iterator5.return();
            }
          } finally {
            if (_didIteratorError5) {
              throw _iteratorError5;
            }
          }
        }
      }
    }.bind(_this), 0);
  });
}

function _makeEvents() {
  tpl.makeEvents(this.$.all('[events]'), this);
}

function _getView() {
  return window._cachedViews[this.pathName] || {};
}

var _class$4 = function (_Route) {
  inherits(_class, _Route);

  function _class(states) {
    classCallCheck(this, _class);

    var _this2 = possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this));

    _this2.states = states;
    _this2._prevPaths = [];
    return _this2;
  }

  createClass(_class, [{
    key: 'bindHash',
    value: function bindHash() {
      var _this3 = this;

      var that = this;
      this.bind('*', function (paths) {
        if (that.makeRoute(paths)) {
          location.hash = '#' + _this3.routeUrl;
        } else {
          setTimeout(function () {
            that.go(-1);
          });
        }
      });
      window.addEventListener('hashchange', function () {
        _this3.go(location.hash.substr(1));
      });
    }
  }, {
    key: 'makeRoute',
    value: function makeRoute(paths) {
      var _this4 = this;

      if (!paths) paths = this._routeHistories[this._routeHistoryPos];
      if (!paths) return;
      // 预处理
      var parentView = this.Root;
      var availablePaths = [];
      var samePos = -1;
      if (window._cachedViews === undefined) {
        // 初始化ROOT
        window._cachedViews = { ROOT: this.Root };
        tpl.make(window.document.body, this.Root.data || {});
        setTimeout(function () {
          tpl.makeEvents($.all('[events]', window.document.body), _this4.Root);
        });
        // this.Root.dom = window.body
        // this.Root.$ = _$.bind(this.Root)
        // this.Root.$.all = _$all.bind(this.Root)
        // this.Root.setData = _setData.bind(this.Root)
        // this.Root.refreshView = _refreshView.bind(this.Root)
        // this.Root.makeEvents = _makeEvents.bind(this.Root)
        // this.Root.go = _go.bind(this.Root)
        // this.Root.refreshView()
        // console.info('---')
      }
      var currentUrls = [];
      for (var i = 0; i < paths.length; i++) {
        var path = paths[i];
        path.view = _getView.bind(path);
        currentUrls.push(path.url);
        var prevPath = this._prevPaths[i];
        var view = window._cachedViews[path.pathName];
        if (!view) {
          if (parentView.getSubView) {
            view = parentView.getSubView(path.name);
          } else if (parentView.subViews) {
            view = parentView.subViews[path.name];
          }
          if (!view) break;
          // 生成dom节点
          view.dom = document.createElement('div');
          if (view.html) {
            // if (/\.html\s*$/.test(view.html)) {
            //   // let xhr = new XMLHttpRequest()
            //   // xhr.open('GET', view.html, false)
            //   // xhr.send()
            //   // view.html = xhr.responseText
            //   view.html = await new Promise(resolve => {
            //     var xhr = new XMLHttpRequest()
            //     xhr.open('GET', view.html)
            //     xhr.onload = function () {
            //       resolve(xhr.responseText || view.html + ' not exists')
            //     }
            //     xhr.onerror = function () {
            //       resolve(view.html + ' not exists')
            //     }
            //     xhr.send()
            //   })
            // }
            view.dom.innerHTML = view.html.replace(/\$this/g, 'window._cachedViews[\'' + path.pathName + '\']').replace('id="SUBVIEW"', 'id="SUBVIEW_' + path.pathName.replace(/\./, '_') + '"');
          }
          window._cachedViews[path.pathName] = view;
          view.route = this;
          view.getViewByName = _getViewByName.bind(view);
          view.getParentView = _getParentView.bind(view);
          view.getNextView = _getNextView.bind(view);
          view.parent = parentView;
          view.nextPath = paths.length - 1 > i ? paths[i + 1] : null;
          view.$ = _$.bind(view);
          view.$.all = _$all.bind(view);
          view.setData = _setData.bind(view);
          view.refreshView = _refreshView.bind(view);
          view.makeEvents = _makeEvents.bind(view);
          view.go = _go.bind(view);

          // 新路由节点调用 onCreate
          if (!view.data) {
            view.data = {};
          }
          if (view.onCreate) {
            view.onCreate({ path: path, prevPath: prevPath, paths: availablePaths });
          }
        }
        availablePaths.push(path);
        view.pathName = path.pathName;
        view.paths = $.copy(availablePaths);
        view.urls = $.copy(currentUrls);

        parentView = view;
        if (prevPath && prevPath.url === path.url && samePos === i - 1) {
          samePos = i;
        }
      }
      // 旧路由中不一样的部分调用 canHide，确认允许跳转
      for (var _i = this._prevPaths.length - 1; _i > samePos; _i--) {
        var _path = _i === -1 ? { pathName: 'ROOT' } : this._prevPaths[_i];
        var _view = _i === -1 ? this.Root : window._cachedViews[_path.pathName];
        if (_view.canHide) {
          if (!_view.canHide(_path, paths)) {
            return false;
          }
        }
      }

      // 旧路由中不一样的部分调用 onHide
      for (var _i2 = this._prevPaths.length - 1; _i2 > samePos; _i2--) {
        var _path2 = _i2 === -1 ? { pathName: 'ROOT' } : this._prevPaths[_i2];
        var _view2 = _i2 === -1 ? this.Root : window._cachedViews[_path2.pathName];
        var _prevPath = (_i2 === 0 ? { pathName: 'ROOT' } : this._prevPaths[_i2 - 1]) || null;
        // let prevView = prevPath ? _cachedViews[prevPath.pathName] : null
        if (_view2.stateRegisters) {
          for (var bindKey in _view2.stateRegisters) {
            this.states.unbind(bindKey, _view2.stateRegisters[bindKey]);
          }
        }
        if (_view2.stateBinds) {
          this.states.unbind(_view2.stateBinds, _view2);
        }

        if (_view2.onHide) _view2.onHide({ path: _path2, prevPath: _prevPath, paths: availablePaths });
        if (_prevPath) {
          var container = document.querySelector('#SUBVIEW_' + _prevPath.pathName.replace(/\./, '_'));
          if (container) {
            _moveNodes(_view2.dom, container);
          }
        }
      }

      // 新路由中不一样的部分调用 onShow
      for (var _i3 = Math.min(0, samePos); _i3 < availablePaths.length; _i3++) {
        var _path3 = _i3 === -1 ? { pathName: 'ROOT' } : availablePaths[_i3];
        var _view3 = window._cachedViews[_path3.pathName];
        var _prevPath2 = _i3 > 1 ? availablePaths[_i3 - 1] : null;
        var nextPath = _i3 < availablePaths.length - 1 ? availablePaths[_i3 + 1] : null;
        var nextView = nextPath ? window._cachedViews[nextPath.pathName] : null;
        var oldPath = this._prevPaths[_i3] || {};

        // 路由中未变化的部分
        if (_i3 < samePos) {
          if (_view3.onCheckShowed) _view3.onCheckShowed({
            oldPath: oldPath,
            path: _path3,
            prevPath: _prevPath2,
            paths: availablePaths,
            nextPath: nextPath,
            nextView: nextView
          });
          continue;
        }

        if (nextView) {
          nextView.parentPathName = _path3.pathName;
          if (_view3.data) {
            // 默认维护 subName
            _view3.data.subName = nextPath.name;
          }
          // nextView.$ = this.$
          // console.info(999, '#SUBVIEW_' + path.pathName.replace(/\./, '_'), document.querySelector('#SUBVIEW_' + path.pathName.replace(/\./, '_')))
          var _container = document.querySelector('#SUBVIEW_' + _path3.pathName.replace(/\./, '_'));
          if (_container) {
            _moveNodes(_container, nextView.dom);
          }
        }

        // 路由参数并入 view.data
        if (_view3.routeBinds) {
          var _iteratorNormalCompletion6 = true;
          var _didIteratorError6 = false;
          var _iteratorError6 = undefined;

          try {
            for (var _iterator6 = _view3.routeBinds[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
              var k = _step6.value;

              _view3.data[k] = _path3.args[k];
            }
          } catch (err) {
            _didIteratorError6 = true;
            _iteratorError6 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion6 && _iterator6.return) {
                _iterator6.return();
              }
            } finally {
              if (_didIteratorError6) {
                throw _iteratorError6;
              }
            }
          }
        }

        // 路由中未变化的部分
        if (_i3 == samePos) {
          if (_view3.onCheckShowed) _view3.onCheckShowed({
            oldPath: oldPath,
            path: _path3,
            prevPath: _prevPath2,
            paths: availablePaths,
            nextPath: nextPath,
            nextView: nextView
          });
        }

        if (_i3 > samePos) {
          if (!_view3.created) {
            _view3.created = true;
            if (_view3.onCreated) _view3.onCreated({ path: _path3, prevPath: _prevPath2, paths: availablePaths, nextPath: nextPath, nextView: nextView });
            modules.make(_view3); // 处理模块
          }

          // console.info(' *******************\n', oldPath, path)
          // 路由变化触发 onShow
          if (_view3.onShow) _view3.onShow({ oldPath: oldPath, path: _path3, prevPath: _prevPath2, paths: availablePaths, nextPath: nextPath, nextView: nextView });

          // 自动绑定state，并触发一次所有绑定事件
          if (_view3.stateRegisters) {
            for (var _bindKey in _view3.stateRegisters) {
              var bindTarget = _view3.stateRegisters[_bindKey];
              this.states.bind(_bindKey, bindTarget);
              // console.info(111, bindKey, typeof bindTarget, bindTarget.setData, typeof bindTarget.setData)
              if (typeof bindTarget === 'function') {
                bindTarget(this.states.get(_bindKey));
              } else if (bindTarget instanceof Array && bindTarget.length === 2) {
                if (typeof bindTarget[1] === 'function') {
                  bindTarget[1].call(bindTarget[0], this.states.get(_bindKey));
                } else if (typeof bindTarget[0][bindTarget[1]] === 'function') {
                  bindTarget[0][bindTarget[1]].call(bindTarget[0], this.states.get(_bindKey));
                }
              } else if ((typeof bindTarget === 'undefined' ? 'undefined' : _typeof(bindTarget)) === 'object' && typeof bindTarget.setData === 'function') {
                bindTarget.setData(this.states.get(_bindKey));
              }
            }
          }

          // console.info('>>>', view.pathName, view.stateBinds)
          if (_view3.stateBinds) {
            this.states.bind(_view3.stateBinds, _view3);
            var _iteratorNormalCompletion7 = true;
            var _didIteratorError7 = false;
            var _iteratorError7 = undefined;

            try {
              for (var _iterator7 = _view3.stateBinds[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
                var bind = _step7.value;

                if (typeof bind === 'string') {
                  _view3.data[bind] = this.states.state[bind];
                } else if (bind instanceof Array && bind.length === 2) {
                  _view3.data[bind[1]] = this.states.state[bind[0]];
                }
              }
            } catch (err) {
              _didIteratorError7 = true;
              _iteratorError7 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion7 && _iterator7.return) {
                  _iterator7.return();
                }
              } finally {
                if (_didIteratorError7) {
                  throw _iteratorError7;
                }
              }
            }
          }
        }

        if (_view3.refreshView) _view3.refreshView();
      }

      this._prevPaths = availablePaths;
      return true;
    }
  }]);
  return _class;
}(Route);

exports.Http = _class;
exports.Route = _class$4;
exports.WebSocket = _class$2;
exports.tpl = tpl;
exports.modules = modules;
exports.$ = $;
//# sourceMappingURL=svc-web.cjs.js.map
